exec("./gui/TextOutline.cs");
exec("./gui/scrollProfile.cs");
exec("./gui/BuffTextProfile.cs");
exec("./gui/SuburbiaTabProfile.cs");

exec("./censorship.cs");
exec("./vehicles.cs");
schedule(1000, 0, exec, "Add-Ons/Client_Suburbia/church.cs");
exec("./taxes.cs");
exec("./info.cs");
exec("./buttons.cs");
exec("./police.cs");
exec("./character.cs");
exec("./help.cs");
exec("./bank.cs");
exec("./drugs.cs");
exec("./trade.cs");
exec("./export.cs");

schedule(1000, 0, exec, "Add-Ons/Client_Suburbia/support.cs");

new AudioProfile(Suburbia_BankTransferSound)
{
	description = "AudioGui";
	fileName = "Add-Ons/Client_Suburbia/sounds/gui/bank_transfer.wav";
	preload = true;
};

new AudioProfile(Suburbia_BankWeaponTransferSound)
{
	description = "AudioGui";
	fileName = "Add-Ons/Client_Suburbia/sounds/gui/bank_weapon_transfer.wav";
	preload = true;
};

new AudioProfile(Suburbia_MoneySound)
{
	description = "AudioGui";
	fileName = "Add-Ons/Client_Suburbia/sounds/gui/cha-ching.wav";
	preload = true;
};

function SuburbiaClient::loadVersion()
{
	jettisonReadFile("Add-Ons/Client_Suburbia/version.json");
	SuburbiaClient.version_data = $JSON::Value;
	SuburbiaClient.version = SuburbiaClient.version_data.version;
}

function CreateSuburbiaClient()
{
	if(!isObject(SuburbiaClient))
		new ScriptObject(SuburbiaClient);
	
	// it doesn't look like text elements don't auto-resize on the x-axis and i'm too fuckin lazy to search through all the functions and find the one that might or might not auto-resize
	//    on the x-axis and then figure out the math to center everything so fuck it
	SuburbiaClient.food_offset["Burrito"] = 0;
	SuburbiaClient.food_offset["Cheeseburger"] = -25;
	SuburbiaClient.food_offset["Doughnut"] = -9;
	SuburbiaClient.food_offset["Garbage"] = -7;
	SuburbiaClient.food_offset["Omelet"] = 0;
	SuburbiaClient.food_offset["Salad"] = 7;

	SuburbiaClient.food_offset["Cabbage"] = 2;
	SuburbiaClient.food_offset["Cheese"] = 12;
	SuburbiaClient.food_offset["Corn"] = 16;
	SuburbiaClient.food_offset["Egg"] = 24;
	SuburbiaClient.food_offset["Meat"] = 22;
	SuburbiaClient.food_offset["Wheat"] = 10;
	
	SuburbiaClient.food_offset["Puff"] = 25;
	SuburbiaClient.food_offset["Krunt"] = 15;
	SuburbiaClient.food_offset["Henk"] = 17;
	SuburbiaClient.food_offset["Boom"] = 15;

	SuburbiaClient.food_offset["Gold"] = 18;
	SuburbiaClient.food_offset["Uranium"] = 2;
	SuburbiaClient.food_offset["Volcanium"] = -7;
	SuburbiaClient.food_offset["Mystery Meat"] = -14;
	
	SuburbiaClient.crafting_offset["Burrito"] = -8;
	SuburbiaClient.crafting_offset["Cheeseburger"] = -35;
	SuburbiaClient.crafting_offset["Doughnut"] = -20;
	SuburbiaClient.crafting_offset["Garbage"] = -16;
	SuburbiaClient.crafting_offset["Omelet"] = -10;
	SuburbiaClient.crafting_offset["Salad"] = -2;

	SuburbiaClient.crafting_offset["Gluttony"] = -8;
	SuburbiaClient.crafting_offset["Greed"] = 2;
	SuburbiaClient.crafting_offset["Hotdog"] = -4;
	SuburbiaClient.crafting_offset["Rage"] = 8;
	SuburbiaClient.crafting_offset["Super Garbage"] = -28;
	SuburbiaClient.crafting_offset["Thirst"] = 2;


	SuburbiaClient.crafting_offset["Bad Assault Rifle"] = -40;
	SuburbiaClient.crafting_offset["Bad Pistol"] = -13;
	SuburbiaClient.crafting_offset["Bad Shotgun"] = -23;
	SuburbiaClient.crafting_offset["Bad SMG"] = -8;
	SuburbiaClient.crafting_offset["Bad Sniper Rifle"] = -35;
	SuburbiaClient.crafting_offset["Knife"] = 9;

	SuburbiaClient.crafting_offset["Gator Collar"] = -20;
	SuburbiaClient.crafting_offset["Gator Whistle"] = -30;
	SuburbiaClient.crafting_offset["Grenade"] = -7;
	SuburbiaClient.crafting_offset["Healthpack"] = -14;
	SuburbiaClient.crafting_offset["Machine Gun"] = -25;
	SuburbiaClient.crafting_offset["Micro SMG"] = -15;
	SuburbiaClient.crafting_offset["Pistol"] = 7;
	SuburbiaClient.crafting_offset["Shotgun"] = -5;

	SuburbiaClient.crafting_offset["C4"] = 18;
	SuburbiaClient.crafting_offset["Chainsaw"] = -12;
	SuburbiaClient.crafting_offset["Combat Shotgun"] = -38;
	SuburbiaClient.crafting_offset["Heavy Machine Gun"] = -43;
	SuburbiaClient.crafting_offset["Magnum"] = -7;
	SuburbiaClient.crafting_offset["Riot Shield"] = -16;
	SuburbiaClient.crafting_offset["Silenced SMG"] = -25;
	SuburbiaClient.crafting_offset["Sport Rifle"] = -13;

	SuburbiaClient.crafting_offset["Chaingun"] = -11;
	SuburbiaClient.crafting_offset["Missile L."] = -8;
	SuburbiaClient.crafting_offset["Super Shotgun"] = -30;
	SuburbiaClient.crafting_offset["Warhead Launcher"] = -39;
	
	SuburbiaClient.loadVersion();
	SuburbiaClient.autoEatLoop();
}
CreateSuburbiaClient();

// you are able to kill anyone on your property
// mayor becomes police chief
// convert the church to islam
// bricks cost money to place/bricks that already cost money cost 25% more
// donation money meant for god is taxed by the government
// every lot you owned is taxed like $50 or some shit per tick
// legalize puff and the puff foods
// limit the spawn rate of alligators
// mayor can set a chat filter that fines people for chatting things

// http://pastebin.com/QQnSdiAt

// instead of laws requiring money to be enacted/unacted it'll be something like a law credit or some shit that regens every minute or so
// when you're elected you get a free law credit

if(!isObject(SRB_Mayor_Laws))
	exec("./gui/Mayor_Laws.gui");

if(!isObject(SRB_Mayor_Fire))
	exec("./gui/SRB_Mayor_Fire.gui");

if(!isObject(SRB_Mayor_Message_Preview))
	exec("./gui/Mayor_Message_Preview.gui");

if(!isObject(SRB_Vehicle_Purchase))
	exec("./gui/Vehicle_Purchase.gui");

if(!isObject(SRB_Pope_WS))
	exec("./gui/Pope_WS.gui");
	
if(!isObject(SRB_Pope_Main))
	exec("./gui/SRB_Pope_Main.gui");

if(!isObject(SRB_Pope_HireFire))
	exec("./gui/SRB_Pope_HireFire.gui");

if(!isObject(SRB_Mayor_Lottery))
	exec("./gui/SRB_Mayor_Lottery.gui");

if(!isObject(SRB_Mayor_TakeGovMoney))
	exec("./gui/SRB_Mayor_TakeGovMoney.gui");

if(!isObject(SRB_PoliceChief_Main))
	exec("./gui/SRB_PoliceChief_Main.gui");

if(!isObject(SRB_PoliceChief_HireFire))
	exec("./gui/SRB_PoliceChief_HireFire.gui");

if(!isObject(SRB_PoliceChief_WS))
	exec("./gui/SRB_PoliceChief_WS.gui");

if(!isObject(SRB_PoliceChief_VS))
	exec("./gui/SRB_PoliceChief_VS.gui");

if(!isObject(SRB_Character_Main))
	exec("./gui/SRB_Character_Main.gui");

if(!isObject(SRB_Bank_Main))
	exec("./gui/SRB_Bank_Main.gui");

if(!isObject(SRB_Bank_Transfer))
	exec("./gui/SRB_Bank_Transfer.gui");

if(!isObject(SRB_Crafting_Main))
	exec("./gui/SRB_Crafting_Main.gui");

if(!isObject(SRB_Crafting_Amount))
	exec("./gui/SRB_Crafting_Amount.gui");

if(!isObject(SRB_Character_Eat))
	exec("./gui/SRB_Character_Eat.gui");

if(!isObject(SRB_Character_FoodInfo))
	exec("./gui/SRB_Character_FoodInfo.gui");

if(!isObject(SRB_Character_Shop))
	exec("./gui/SRB_Character_Shop.gui");

if(!isObject(SRB_Character_ShopUpload))
	exec("./gui/SRB_Character_ShopUpload.gui");

if(!isObject(SRB_Character_ShopUploadWeapons))
	exec("./gui/SRB_Character_ShopUploadWeapons.gui");

if(!isObject(SRB_Character_ShopPurchase))
	exec("./gui/SRB_Character_ShopPurchase.gui");

if(!isObject(SRB_Mayor_Censorship))
	exec("./gui/Mayor_Censorship.gui");

if(!isObject(SRB_Character_ShopUploadItems))
	exec("./gui/SRB_Character_ShopUploadItems.gui");

if(!isObject(SRB_Character_TradeOfferItems))
	exec("./gui/SRB_Character_TradeOfferItems.gui");

if(!isObject(SRB_Character_TradeOfferWeapons))
	exec("./gui/SRB_Character_TradeOfferWeapons.gui");

if(!isObject(SRB_Character_TradeOfferResources))
	exec("./gui/SRB_Character_TradeOfferResources.gui");

if(!isObject(SRB_Character_Trade))
	exec("./gui/SRB_Character_Trade.gui");

if(!isObject(SRB_Character_TradeSelect))
	exec("./gui/SRB_Character_TradeSelect.gui");

if(!isObject(SRB_Export))
	exec("./gui/SRB_Export.gui");

if(!isObject(SRB_Export_Sell))
	exec("./gui/SRB_Export_Sell.gui");

if(!isObject(SRB_Export_SellItems))
	exec("./gui/SRB_Export_SellItems.gui");
	
if(!isObject(SRB_Export_SellWeapons))
	exec("./gui/SRB_Export_SellWeapons.gui");


function createLawIcon(%name, %icon_file, %position)
{
	%gui_name = "SRB_MayorLawIcon_" @ %name;
	
	%icon = new GuiSwatchCtrl(%gui_name)
	{
		clipToParent = 1;
		color = "0 0 0 255";
		enabled = 1;
		extent = "98 116";
		horizSizing = "right";
		minExtent = "1 1";
		position = %position;
		profile = "GuiDefaultProfile";
		vertSizing = "bottom";
		visible = 1;
		
		new GuiBitmapCtrl()
		{
			alignLeft = false;
			alignTop = false;
			bitmap = "Add-Ons/Client_Suburbia/gui/icons/" @ %icon_file @ ".png";
			clipToParent = true;
			enabled = true;
			extent = "94 94";
			horizSizing = "right";
			keepCached = false;
			lockAspectRatio = false;
			mColor = "255 255 255 255";
			minExtent = "1 1";
			mMultiply = false;
			overflowImage = false;
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = true;
			wrap = false;
		};
		
		new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "ServerListProfile";
			selectable = true;
			text = "<color:ffffff><just:center><font:Arial:14>" @ %name;
			caption = %name;
			vertSizing = "bottom";
			visible = true;
		};
		
		new GuiSwatchCtrl()
		{
			clipToParent = 1;
			color = "0 0 0 0";
			enabled = 1;
			position = "0 0";
			extent = "98 116";
			horizSizing = "right";
			minExtent = "1 1";
			position = "0 0";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = 1;
		};
		
		new GuiSwatchCtrl()
		{
			clipToParent = 1;
			color = "0 0 0 0";
			enabled = 1;
			position = "2 2";
			extent = "94 94";
			horizSizing = "right";
			minExtent = "1 1";
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = 1;
		};
		
		new GuiMouseEventCtrl(Mayor_LawIconMouse)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "98 116";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
		};
	};
	Suburbia_MayorLawsScrollBackground.add(%icon);
	%icon.position = %position;
	
	%icon.icon_image = %icon.getObject(0);
	%icon.icon_caption = %icon.getObject(1);
	%icon.white_tint = %icon.getObject(2);
	%icon.yellow_tint = %icon.getObject(3);
	%icon.icon_mouseCtrl = %icon.getObject(4);
	
	%icon.original_position = %position;
	
	%icon.law_name = %real_name;
	
	return %gui_name;
}

function addLawIcon(%name, %icon_file)
{
	if(Suburbia_MayorLawsScroll.suburbia_currentRow $= "")
		Suburbia_MayorLawsScroll.suburbia_currentRow = 1;
	
	// calculate the height that we should be at
	%current_row = Suburbia_MayorLawsScroll.suburbia_currentRow;
	%height = (((%current_row - 1) * 116) + (%current_row * 5));
	
	// determine where along the x axis we should place the icon
	if(Suburbia_MayorLawsScroll.suburbia_row[%current_row, "slot"] $= "")
		Suburbia_MayorLawsScroll.suburbia_row[%current_row, "slot"] = 1;
	
	%current_slot = Suburbia_MayorLawsScroll.suburbia_row[%current_row, "slot"];
	%width = (((%current_slot - 1) * 98) + (%current_slot * 5));
	
	// create the gui and file the icon under an array all at the same time
	%icon = Suburbia_MayorLawsScroll.suburbia_row[%current_slot, Suburbia_MayorLawsScroll.suburbia_row[%current_row, "slot"]] = createLawIcon(%name, %icon_file, %width SPC %height);
	
	// if we have too many icons on one row, increment the total row count so next time we start on a new row
	if(Suburbia_MayorLawsScroll.suburbia_row[%current_row, "slot"] == 3)
		Suburbia_MayorLawsScroll.suburbia_currentRow++;
	else
		Suburbia_MayorLawsScroll.suburbia_row[%current_row, "slot"]++;
		
	// resizing the background so that the scroll works right
	%background_height = (%current_row * 116) + ((%current_row + 1) * 5);
	
	if(%background_height < 292)
		%background_height = 292;
	
	Suburbia_MayorLawsScrollBackground.resize(1, 1, 315, %background_height);
	
	return %icon;
}

function Mayor_LawIconMouse::onMouseDown(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.setMouseDown();
}

function Mayor_LawIconMouse::onMouseUp(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	if(%this.mouseDown)
		%this.setSelectColors();
}

function Mayor_LawIconMouse::onMouseEnter(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.setHoverColors();
}

function Mayor_LawIconMouse::onMouseLeave(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.resetHoverColors();
	
	%scroll = %this.getGroup().getGroup();
	if(%this.mouseDown == true && %this.isSelected == false && %scroll.currently_selected == %this)
		%this.resetSelectColors();
	
	if(%this.mouseDown == true)
		%this.resetMouseDown();
	
	%this.mouseDown = false;
}

function Mayor_LawIconMouse::setHoverColors(%this)
{
	%this.getGroup().white_tint.setColor("255 255 255 90");
	
	%this.hoverActive = true;
}

function Mayor_LawIconMouse::resetHoverColors(%this)
{
	%this.getGroup().white_tint.setColor("0 0 0 0");
	
	%this.hoverActive = false;
}

function Mayor_LawIconMouse::setSelectColors(%this)
{
	%this.resetMouseDown();
	%parent = %this.getGroup();
	
	%parent.yellow_tint.setColor("255 255 0 115");
	%parent.icon_caption.setValue("<color:FFFF00><just:center><font:Arial:14>" @ %parent.icon_caption.caption);
	
	%scroll = %parent.getGroup();
	if(isObject(%scroll.currently_selected) && %scroll.currently_selected != %this)
		%scroll.currently_selected.resetSelectColors();
	
	// set the description shit
	Suburbia_MayorLawsDescTitle.setValue("<just:center><font:Arial bold:24>" @ %parent.law_name);
	
	%enact_or_repeal = ($Suburbia::Mayor::Laws[%parent.law_name, "enacted"] == true) ? "repeal" : "enact";
	// %cost = (%enact_or_repeal $= "enact") ? $Suburbia::Mayor::Laws[%parent.law_name, "cost"] : $Suburbia::Mayor::Laws[%parent.law_name, "cost"] / 2;
	// Suburbia_MayorLawsDescCost.setValue("<just:center><font:Arial italic:15> costs $" @ %cost SPC "to" SPC %enact_or_repeal);
	
	// getting the enacted meter
	for(%i = 1; %i <= $Suburbia::Mayor::Meters[%parent.law_name, "meter_count"]; %i++)
		if($Suburbia::Mayor::Meters[%parent.law_name, %i, "enacted"])
			%meter = %i;
	
	if(%meter)
		%money = $Suburbia::Mayor::Meters[%parent.law_name, %meter, "money"];
	else
		%money = $Suburbia::Mayor::Laws[%parent.law_name, "money"];
	
	if($Suburbia::Mayor::Meters[%parent.law_name, %meter, "cost"] !$= "")
		Suburbia_MayorLawsDescCost.setValue("<just:center><font:Arial italic:15> costs" SPC $Suburbia::Mayor::Meters[%parent.law_name, %meter, "cost"] SPC "law point" @ ($Suburbia::Mayor::Meters[%parent.law_name, %meter, "cost"] != 1 ? "s" : "") SPC "and $" @ $Suburbia::Mayor::Meters[%parent.law_name, %meter, "money"] SPC "to enact");
	else
		Suburbia_MayorLawsDescCost.setValue("<just:center><font:Arial italic:15> costs 1 law point and $" @ %money SPC "to" SPC %enact_or_repeal);
	
	Suburbia_MayorLawsDescButton.setVisible(true);
	Suburbia_MayorLawsDescButton.setActive(true);
	if(%enact_or_repeal $= "enact")
	{
		Suburbia_MayorLawsDescButton.mColor = "50 220 50 255";
		Suburbia_MayorLawsDescButton.setText("Enact");
	}
	else
	{
		Suburbia_MayorLawsDescButton.mColor = "220 50 50 255";
		Suburbia_MayorLawsDescButton.setText("Repeal");
	}
	
	%desc_parent = Suburbia_MayorLawsDescParent;
	%count = %desc_parent.getCount();
	%real_name = %parent.law_name;
	// remove the old benefit / disbenefit messages
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%obj = %desc_parent.getObject(%i);
		
		if(isObject(%obj))
			if(%obj.getName() $= "Suburbia_MayorLawsDescContent")
				%obj.delete();
	}
	
	// place the benefits / disbenefits
	%desc_count = 1;
	%position = 86;
	for(%i = 1; %i < 6; %i++)
	{
		%index = "affect" @ %i;
		
		if($Suburbia::Mayor::Laws[%real_name, %index] !$= "")
		{
			%text = $Suburbia::Mayor::Laws[%real_name, %index];
			
			%desc = new GuiMLTextCtrl(Suburbia_MayorLawsDescContent)
			{
				allowColorChars = true;
				autoResize = true;
				clipToParent = true;
				enabled = true;
				extent = "240 0";
				horizSizing = "right";
				lineSpacing = 2;
				maxBitmapHeight = -1;
				maxChars = -1;
				minExtent = "8 2";
				position = "0 0";
				profile = "GuiMLTextProfile";
				selectable = true;
				text = "";
				caption = %name;
				vertSizing = "bottom";
				visible = true;
			};
			%desc_parent.add(%desc);
			%desc.setText("<font:Arial:17><lmargin:20>- " @ setWord(%text, 2, "<lmargin:33>" @ getWord(%text, 2)));
			%desc.forceReflow();
			%desc.position = 0 SPC %position;
			%position += getWord(%desc.extent, 1) + 6;
		}
		else
			break;
	}
	
	%scroll.currently_selected = %this;
	%this.isSelected = true;
	
	if($Suburbia::Mayor::Meters[%parent.law_name])
	{
		Mayor_CreateMeter($Suburbia::Mayor::Meters[%parent.law_name, "meter_count"], %parent.law_name);
		Mayor_ColorEnactedMeter();
		Mayor_DisplayMeterDescription();
		
		Suburbia_MayorLawsDescButton.setActive(false);
		Suburbia_MayorLawsDescButton.setText("Already Enacted");
	}
	else
		Mayor_DeleteMeter();
}

function Mayor_LawIconMouse::resetSelectColors(%this)
{
	%this.getGroup().yellow_tint.setColor("0 0 0 0");
	%this.getGroup().icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:14>" @ %this.getGroup().icon_caption.caption);
	
	%scroll = %this.getGroup().getGroup();
	if(isObject(%scroll.currently_selected) && %scroll.currently_selected != %this)
		%scroll.currently_selected.resetSelectColors();
	
	%scroll.currently_selected = "";
	
	%this.isSelected = false;
}

function Mayor_LawIconMouse::setMouseDown(%this)
{
	%parent = %this.getGroup();
	
	if(%parent.original_position $= "")
		%parent.original_position = %parent.position;
	
	%position = %parent.original_position;
	%parent.resize(getWord(%position, 0) + 2, getWord(%position, 1) + 2, 94, 112);
	
	if(!%this.isSelected)
		%parent.icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:12>" @ %this.getGroup().icon_caption.caption);
	else
		%parent.icon_caption.setValue("<color:FFFF00><just:center><font:Arial:12>" @ %this.getGroup().icon_caption.caption);
	
	%parent.icon_caption.resize(0, 96, 92, 20);
	
	%parent.icon_image.resize(2, 2, 90, 90);
	%parent.yellow_tint.resize(2, 2, 90, 90);
	
	%this.mouseDown = true;
}

function Mayor_LawIconMouse::resetMouseDown(%this)
{
	%parent = %this.getGroup();
	
	%position = %parent.original_position;
	%parent.resize(getWord(%position, 0), getWord(%position, 1), 98, 116);
	
	%parent.icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:14>" @ %this.getGroup().icon_caption.caption);
	%parent.icon_caption.resize(0, 99, 96, 20);
	
	%parent.icon_image.resize(2, 2, 94, 94);
	%parent.yellow_tint.resize(2, 2, 94, 94);
	
	%this.mouseDown = false;
}

function Mayor_CreateMeter(%num, %law)
{
	Mayor_DeleteMeter();
	for(%i = 0; %i < %num; %i++)
	{
		%gui = new GuiBitmapButtonCtrl(SRB_Mayor_Meter_Button)
		{
			profile = BlockButtonProfile;
			position = "55 247";
			extent = "20 20";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			text = %i + 1;
			buttonType = "PushButton";
			bitmap = "base/client/ui/button2";
			mColor = "255 255 255 255";
		};
		%gui.command = "Mayor_PressMeter(" @ %gui @ ");";
		%gui.law = %law;
		Suburbia_MayorLawsDescParent.add(%gui);
		
		$Suburbia::Mayor::DisplayedMeters[%i + 1] = %gui;
		
		%x = (%i * 22);
		%mod = (126 - (%num * 22) / 2) + 1;
		%gui.position = %x + %mod SPC "247";
	}
	$Suburbia::Mayor::DisplayedMetersCount = %num;
}

function Mayor_DeleteMeter()
{
	while(isObject(SRB_Mayor_Meter_Button))
		SRB_Mayor_Meter_Button.delete();
}

function Mayor_PressMeter(%gui)
{
	$Suburbia::SelectedMeter.mColor = "255 255 255 255";
	
	if($Suburbia::Mayor::Meters[%gui.law, %gui.text, "enacted"])
	{
		Suburbia_MayorLawsDescButton.setActive(false);
		Suburbia_MayorLawsDescButton.setText("Already Enacted");
	}
	else
	{
		Suburbia_MayorLawsDescButton.setActive(true);
		Suburbia_MayorLawsDescButton.setText("Enact");
	}
	
	Suburbia_MayorLawsDescCost.setValue("<just:center><font:Arial italic:15> costs" SPC $Suburbia::Mayor::Meters[%gui.law, %gui.text, "cost"] SPC "law point" @ ($Suburbia::Mayor::Meters[%gui.law, %gui.text, "cost"] != 1 ? "s" : "") SPC "and $" @ $Suburbia::Mayor::Meters[%gui.law, %gui.text, "money"] SPC "to enact");
	
	%gui.mColor = "90 96 254 255";
	$Suburbia::SelectedMeter = %gui;
	
	Mayor_DisplayMeterDescription();
}

// colors the currently enacted meter
function Mayor_ColorEnactedMeter()
{
	for(%i = 1; %i <= $Suburbia::Mayor::DisplayedMetersCount; %i++)
	{
		%law_name = $Suburbia::Mayor::DisplayedMeters[%i].law;
		%meter_num = $Suburbia::Mayor::DisplayedMeters[%i].text;
		
		if($Suburbia::Mayor::Meters[%law_name, %meter_num, "enacted"])
		{
			$Suburbia::Mayor::DisplayedMeters[%i].mColor = "90 96 254 255";
			$Suburbia::SelectedMeter = $Suburbia::Mayor::DisplayedMeters[%i];
		}
		else
			$Suburbia::Mayor::DisplayedMeters[%i].mColor = "255 255 255 255";
	}
}

function Mayor_DisplayMeterDescription()
{
	%desc_parent = Suburbia_MayorLawsDescParent;
	%count = %desc_parent.getCount();
	// remove the old benefit / disbenefit messages
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%obj = %desc_parent.getObject(%i);
		
		if(isObject(%obj))
			if(%obj.getName() $= "Suburbia_MayorLawsDescContent")
				%obj.delete();
	}
	
	// creates the meter's description
	%law_name = $Suburbia::SelectedMeter.law;
	%meter_num = $Suburbia::SelectedMeter.text;
	
	%desc_count = 1;
	%position = 86;
	for(%i = 1; %i < 6; %i++)
	{
		%index = "affect" @ %i;
		
		if($Suburbia::Mayor::Meters[%law_name, %meter_num, %index] !$= "")
		{
			%text = $Suburbia::Mayor::Meters[%law_name, %meter_num, %index];
			
			%desc = new GuiMLTextCtrl(Suburbia_MayorLawsDescContent)
			{
				allowColorChars = true;
				autoResize = true;
				clipToParent = true;
				enabled = true;
				extent = "240 0";
				horizSizing = "right";
				lineSpacing = 2;
				maxBitmapHeight = -1;
				maxChars = -1;
				minExtent = "8 2";
				position = "0 0";
				profile = "GuiMLTextProfile";
				selectable = true;
				text = "";
				caption = %name;
				vertSizing = "bottom";
				visible = true;
			};
			%desc_parent.add(%desc);
			%desc.setText("<font:Arial:17><lmargin:20>- " @ setWord(%text, 2, "<lmargin:33>" @ getWord(%text, 2)));
			%desc.forceReflow();
			%desc.position = 0 SPC %position;
			%position += getWord(%desc.extent, 1) + 6;
		}
		else
			break;
	}
}

function clientCmdReceiveMeter(%law_name, %affect_1, %affect_2, %affect_3, %affect_4, %affect_5, %affect_6, %meter_num, %enacted, %cost, %money, %default)
{
	addMeter(%law_name, %affect_1, %affect_2, %affect_3, %affect_4, %affect_5, %affect_6, %meter_num, %enacted, %cost, %money);
	$Suburbia::Mayor::Meters[%law_name, "default"] = %default;
}

function addMeter(%law_name, %affect_1, %affect_2, %affect_3, %affect_4, %affect_5, %affect_6, %meter_num, %enacted, %cost, %money)
{
	$Suburbia::Mayor::Meters[%law_name] = true;
	
	// setting the different affects for the law description
	$Suburbia::Mayor::Meters[%law_name, %meter_num, "affect1"] = %affect_1;
	
	if(%affect_2 !$= "")
		$Suburbia::Mayor::Meters[%law_name, %meter_num, "affect2"] = %affect_2;
	
	if(%affect_3 !$= "")
		$Suburbia::Mayor::Meters[%law_name, %meter_num, "affect3"] = %affect_3;
	
	if(%affect_4 !$= "")
		$Suburbia::Mayor::Meters[%law_name, %meter_num, "affect4"] = %affect_4;
	
	if(%affect_5 !$= "")
		$Suburbia::Mayor::Meters[%law_name, %meter_num, "affect5"] = %affect_5;
	
	if(%affect_6 !$= "") 
		$Suburbia::Mayor::Meters[%law_name, %meter_num, "affect6"] = %affect_6;
	
	$Suburbia::Mayor::Meters[%law_name, %meter_num, "enacted"] = %enacted;
	
	$Suburbia::Mayor::Meters[%law_name, %meter_num, "cost"] = %cost;
	$Suburbia::Mayor::Meters[%law_name, %meter_num, "money"] = %money;
	
	$Suburbia::Mayor::Meters[%law_name, "meter_count"]++;
}

function clientCmdUpdateMeter(%law_name, %meter_num, %enacted_or_not_enacted)
{
	$Suburbia::Mayor::Meters[%law_name, %meter_num, "enacted"] = %enacted_or_not_enacted;
	
	if($Suburbia::SelectedMeter.text == %meter_num && $Suburbia::SelectedMeter.law $= %law_name)
	{
		Suburbia_MayorLawsDescButton.setActive(false);
		Suburbia_MayorLawsDescButton.setText("Already Enacted");
	}
}

function getTaggedFieldCount(%obj)
{
	%count = 0;
	while((%field = %obj.getTaggedField(%count)) !$= "")
		%count++;
	
	return %count;
}

function clearScrollList()
{
	%count = getTaggedFieldCount(Suburbia_MayorLawsScroll);
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%field = Suburbia_MayorLawsScroll.getTaggedField(%i);
		%field_name = expandEscape(getField(%field, 0));
		eval("Suburbia_MayorLawsScroll." @ %field_name @ " = \"\";");
	}
	
	%count = Suburbia_MayorLawsScrollBackground.getCount();
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%obj = Suburbia_MayorLawsScrollBackground.getObject(%i);
		
		if(isObject(%obj))
			%obj.delete();
	}
}

// <font:Arial:17><lmargin:20>- 50% <lmargin:33>of all gov revenue donated to church
// 50 220 50 255 for enact button
// 220 50 50 255 for repeal button

function clearLaws()
{
	DeleteVariables("$Suburbia::Mayor::Law*");
	DeleteVariables("$Suburbia::Mayor::Meter*");
	clearScrollList();
}

function displayLaws(%section)
{
	clearScrollList();
	for(%i = 0; %i < $Suburbia::Mayor::LawCount; %i++)
	{
		%law_name = $Suburbia::Mayor::Laws[%i];
		%law_section = $Suburbia::Mayor::Laws[%law_name, "section"];
		%law_caption = $Suburbia::Mayor::Laws[%law_name, "caption"];
		%law_icon = $Suburbia::Mayor::Laws[%law_name, "icon"];
		
		if(%law_section == %section)
		{
			%icon = addLawIcon(%law_caption, %law_icon);
			%icon.law_name = %law_name;
		}
	}
}

function addLaw(%real_name, %icon_name, %icon_file, %section, %money, %affect_1, %affect_2, %affect_3, %affect_4, %affect_5, %affect_6)
{
	$Suburbia::Mayor::Laws[%real_name] = true;
	$Suburbia::Mayor::Laws[%real_name, "caption"] = %icon_name;
	$Suburbia::Mayor::Laws[%real_name, "icon"] = %icon_file;
	$Suburbia::Mayor::Laws[%real_name, "section"] = %section;
	$Suburbia::Mayor::Laws[%real_name, "money"] = %money;
	
	// setting the different affects for the law description
	$Suburbia::Mayor::Laws[%real_name, "affect1"] = %affect_1;
	
	if(%affect_2 !$= "")
		$Suburbia::Mayor::Laws[%real_name, "affect2"] = %affect_2;
	
	if(%affect_3 !$= "")
		$Suburbia::Mayor::Laws[%real_name, "affect3"] = %affect_3;
	
	if(%affect_4 !$= "")
		$Suburbia::Mayor::Laws[%real_name, "affect4"] = %affect_4;
	
	if(%affect_5 !$= "")
		$Suburbia::Mayor::Laws[%real_name, "affect5"] = %affect_5;
	
	if(%affect_6 !$= "") 
		$Suburbia::Mayor::Laws[%real_name, "affect6"] = %affect_6;
	
	$Suburbia::Mayor::Laws[%real_name, "enacted"] = false;
	
	if($Suburbia::Mayor::LawCount $= "")
		$Suburbia::Mayor::LawCount = 0;
	
	$Suburbia::Mayor::Laws[$Suburbia::Mayor::LawCount] = %real_name;
	$Suburbia::Mayor::LawCount++;
	
	// creating the icon
	// %icon = addLawIcon(%icon_name, %icon_file);
	// %icon.law_name = %real_name;
}

function showMayorLawsGui()
{
	resetSelectedLawIcon();
	CommandToServer('RequestGovUpdate');
	Canvas.schedule(1, pushDialog, SRB_Mayor_Laws);
}

function clientCmdDisplayMayorGui()
{
	if($Suburbia::HandshakeCompleted == true)
		showMayorLawsGui();
}

function resetSelectedLawIcon()
{
	if(isObject(Suburbia_MayorLawsScrollBackground.currently_selected))
		if(isFunction(Suburbia_MayorLawsScrollBackground.currently_selected.getName(), resetSelectColors))
			Suburbia_MayorLawsScrollBackground.currently_selected.resetSelectColors();
		
	// remove the benefit descriptions
	%desc_parent = Suburbia_MayorLawsDescParent;
	%count = %desc_parent.getCount();
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%obj = %desc_parent.getObject(%i);
		
		if(isObject(%obj))
			if(%obj.getName() $= "Suburbia_MayorLawsDescContent")
				%obj.delete();
	}
	
	Suburbia_MayorLawsDescCost.setText("");
	Suburbia_MayorLawsDescTitle.setText("");
	Suburbia_MayorLawsDescButton.setVisible(false);
	
	Mayor_DeleteMeter();
}

function Suburbia_MayorLawsDescButton::sendLawToServer(%this)
{
	%law_name = trim(stripMLControlChars(Suburbia_MayorLawsDescTitle.getText()));
	
	if(!isObject($Suburbia::SelectedMeter))
		CommandToServer('UpdateLaw', %law_name, !$Suburbia::Mayor::Laws[%law_name, "enacted"]);
	else
		CommandToServer('UpdateLaw', %law_name SPC $Suburbia::SelectedMeter.text, true);
}

function clientCmdReceiveLaw(%real_name, %caption, %icon_file, %section, %money, %affect_1, %affect_2, %affect_3, %affect_4, %affect_5, %affect_6, %enacted)
{
	addLaw(%real_name, %caption, %icon_file, %section, %money, %affect_1, %affect_2, %affect_3, %affect_4, %affect_5, %affect_6);
	clientCmdUpdateLaw(%real_name, %enacted);
	
	// echo("LAW ADDED >> " @ %real_name);
}

function addCommasToNumber(%num)
{
	if(%num == 0)
		return 0;
	
	if(strPos(%num, "-") != -1)
	{
		%neg = "-";
		%num = strReplace(%num, "-", "");
	}
	
	%len = strLen(%num);
	
	if(%len < 3)
		return %num;
	
	%final_num = "";
	%count = -1;
	for(%i = %len; %i >= 0; %i--)
	{
		%single_num = getSubStr(%num, %i, 1);
		
		if(%count % 3 == 0 && %count > 0)
			%final_num = %single_num @ "," @ %final_num;
		else
			%final_num = %single_num @ %final_num;
		
		%count++;
	}
	
	return %neg @ %final_num;
}

// for updating the enacted/repealed part of the law
function clientCmdUpdateLaw(%law_name, %enacted_or_not_enacted)
{
	// true == enacted
	// false == not enacted
	
	$Suburbia::Mayor::Laws[%law_name, "enacted"] = %enacted_or_not_enacted;
	
	// seeing what we currently have selected in the gui
	
	if(Suburbia_MayorLawsScrollBackground.currently_selected.getGroup().law_name $= %law_name) 
	{
		if($Suburbia::Mayor::Laws[%law_name, "enacted"] == true)
		{
			Suburbia_MayorLawsDescButton.mColor = "220 50 50 255";
			Suburbia_MayorLawsDescButton.setText("Repeal");
			// Suburbia_MayorLawsDescCost.setValue("<just:center><font:Arial italic:15> costs $" @ $Suburbia::Mayor::Laws[%law_name, "cost"] / 2 SPC "to repeal");
			Suburbia_MayorLawsDescCost.setValue("<just:center><font:Arial italic:15> costs 1 law point and $" @ $Suburbia::Mayor::Meters[%parent.law_name, %meter, "money"] SPC "to repeal and ");
		}
		else
		{
			Suburbia_MayorLawsDescButton.mColor = "50 220 50 255";
			Suburbia_MayorLawsDescButton.setText("Enact");
			// Suburbia_MayorLawsDescCost.setValue("<just:center><font:Arial italic:15> costs $" @ $Suburbia::Mayor::Laws[%law_name, "cost"] SPC "to enact");
			Suburbia_MayorLawsDescCost.setValue("<just:center><font:Arial italic:15> costs 1 law point and $" @ $Suburbia::Mayor::Meters[%parent.law_name, %meter, "money"] SPC "to enact");
		}
	}
}

// update government funds
function clientCmdUpdateGovFunds(%amt)
{
	if(strPos(%amt, "-") != -1)
		%neg = "-";
	
	Suburbia_MayorMoneyText.setText("<color:bbbbbb><font:Calibri:21>Funds: <color:00cc00>" @ %neg @ "$" @ addCommasToNumber(%amt));
	
	Suburbia_MayorLawPointText.position = 50 + (strLen(stripMLControlChars(Suburbia_MayorMoneyText.getValue())) * 6) SPC "351";
}


function clientCmdUpdateLawPoints(%amt)
{
	Suburbia_MayorLawPointText.setText("<color:bbbbbb><font:Calibri:21>Law Points: <color:eeee00>" @ %amt);
	Suburbia_MayorLawPointText2.setText("<color:bbbbbb><font:Calibri:21>Law Points: <color:eeee00>" @ %amt);
	Suburbia_MayorLawPointText3.setText("<color:bbbbbb><font:Calibri:21>Law Points: <color:eeee00>" @ %amt);
}

function clientCmdRequestShaders()
{
	CommandToServer('ReceiveShaders', $Pref::ShaderQuality);
}

function suburbia_onTaxChange(%val)
{
	SuburbiaClient.value["tax"] = mFloor(%val * 100);
	
	Suburbia_MayorTaxText.setValue("<just:center><color:ffff00><font:Calibri Bold:26>Tax: <color:ffffff>" @ SuburbiaClient.value["tax"] @ "%");
}



function setMayorTab(%tab)
{
	if(%tab == 0)
	{
		SRB_Mayor_Laws_Control.visible = true;
		SRB_Mayor_City_Control.visible = false;
		SRB_Mayor_Budget_Control.visible = false;
		SRB_Mayor_Window.extent = "607 439";
		Suburbia_MayorMoneyText.position = "9 412";
	}
	else if(%tab == 1)
	{
		SRB_Mayor_Laws_Control.visible = false;
		SRB_Mayor_City_Control.visible = true;
		SRB_Mayor_Budget_Control.visible = false;
		SRB_Mayor_Window.extent = "607 463";
		Suburbia_MayorMoneyText.position = "9 437";
	}
	else if(%tab == 2)
	{
		SRB_Mayor_Laws_Control.visible = false;
		SRB_Mayor_City_Control.visible = false;
		SRB_Mayor_Budget_Control.visible = true;
		SRB_Mayor_Window.extent = "607 475";
		Suburbia_MayorMoneyText.position = "9 448";
	}
}


function clientCmdClearNewscasters()
{
	Suburbia_Newscaster_List.clear();
	SuburbiaClient.newscaster_count = 0;
}

function clientCmdReceiveNewscaster(%newscaster)
{
	SuburbiaClient.newscaster_count++;
	Suburbia_Newscaster_List.add(%newscaster, SuburbiaClient.newscaster_count);
	SuburbiaClient.newscaster[%newscaster] = true;
}

function clientCmdUpdateNewscaster(%newscaster)
{
	Suburbia_Newscaster_List.setValue(%newscaster);
}



function clientCmdUpdatePoliceBudget(%amt)
{
	Suburbia_PoliceBudgetSlider.setValue(%amt / 100000);
	suburbia_onPoliceBudgetChange(%amt / 100000);
}

function suburbia_onPoliceBudgetChange(%val)
{
	SuburbiaClient.value["police budget"] = mFloor(%val * 100);
	
	// updating church budget slider
	%church = mClampF(SuburbiaClient.value["church budget"] / 100, 0, 1 - (SuburbiaClient.value["police budget"] / 100));
	SuburbiaClient.value["church budget"] = mFloor(%church * 100);
	Suburbia_ChurchBudgetSlider.setValue(%church);
	Suburbia_MayorChurchBudgetText.setValue("<just:center><color:ffff00><font:Calibri Bold:26>Church Budget: <color:ffffff>" @ SuburbiaClient.value["church budget"] @ "%");
	
	Suburbia_MayorPoliceBudgetText.setValue("<just:center><color:ffff00><font:Calibri Bold:26>Police Budget: <color:ffffff>" @ SuburbiaClient.value["police budget"] @ "%");
}

function suburbia_onChurchBudgetChange(%val)
{
	SuburbiaClient.value["church budget"] = mFloor(%val * 100);
	
	// updating police budget slider
	%police = mClampF(SuburbiaClient.value["police budget"] / 100, 0, 1 - (SuburbiaClient.value["church budget"] / 100));
	SuburbiaClient.value["police budget"] = mFloor(%police * 100);
	Suburbia_PoliceBudgetSlider.setValue(%police);
	Suburbia_MayorPoliceBudgetText.setValue("<just:center><color:ffff00><font:Calibri Bold:26>Police Budget: <color:ffffff>" @ SuburbiaClient.value["police budget"] @ "%");
	
	Suburbia_MayorChurchBudgetText.setValue("<just:center><color:ffff00><font:Calibri Bold:26>Church Budget: <color:ffffff>" @ SuburbiaClient.value["church budget"] @ "%");
}

function suburbia_onCraftingPassChange(%val)
{
	%val = mFloor(%val * 50);
	
	SuburbiaClient.value["crafting pass"] = %val;
	Suburbia_MayorCraftingPassText.setValue("<just:center><color:ffff00><font:Calibri Bold:26>Crafting Pass Cost: <color:00cc00>$" @ SuburbiaClient.value["crafting pass"] @ "");
}

function clientCmdUpdateGovBudget(%police, %church)
{
	suburbia_onPoliceBudgetChange(%police);
	suburbia_onChurchBudgetChange(%church);
}

function clientCmdUpdateCraftingPass(%val)
{
	suburbia_onCraftingPassChange(%val);
	Suburbia_CraftingPassSlider.setValue(%val);
}

function suburbia_sendCityUpdate()
{
	CommandToServer('UpdateNewscaster', Suburbia_Newscaster_List.getValue());
	
	%msg_raw = SRB_Mayor_MessageBoardText.getValue();
	%msg = suburbia_formatEnterKey(%msg_raw);
	CommandToServer('UpdateMayorBoard', getSubStr(%msg, 0, 254), getSubStr(%msg, 254, 151), getSubStr(%msg_raw, 0, 254), getSubStr(%msg_raw, 254, 151));
	
	suburbia_sendTaxUpdate();
}

function suburbia_sendBudgetUpdate()
{
	// CommandToServer('UpdateGovTax', SuburbiaClient.value["tax"] / 100);
	CommandToServer('UpdateMayorBudgets', SuburbiaClient.value["police budget"] / 100, SuburbiaClient.value["church budget"] / 100);
	CommandToServer('UpdateMayorCraftingPass', SuburbiaClient.value["crafting pass"]);
}

function showMayorMessagePreview()
{
	suburbia_previewMayorMessage(SRB_Mayor_MessageBoardText.getValue());
	Canvas.schedule(1, pushDialog, SRB_Mayor_Message_Preview);
}

function clientCmdUpdateMessageBoard(%msg1, %msg2)
{
	SRB_Mayor_MessageBoardText.setValue(%msg1 @ %msg2);
}

function createCharacter(%character, %num)
{
	%str = "";
	for(%i = 0; %i < %num; %i++)
		%str = %str @ %character;
	
	return %str;
}

function suburbia_formatEnterKey(%msg)
{
	for(%i = 0; %i < 11; %i++)
	{
		%stop = false;
		
		for(%x = 0; %x < 32; %x++)
		{
			if(%stop == false)
			{
				%thing = getSubStr(%msg, (%i * 32) + %x, 1);
				
				if(%thing $= "\n")
				{
					%final_msg = %final_msg SPC createCharacter(" ", 32 - (%x + 1));
					%msg = %final_msg @ getSubStr(%msg, ((%i * 32) + %x) + 1, strLen(%msg));
					
					break;
				}
				else
					%final_msg = %final_msg @ %thing;
			}
		}
	}
	
	return %final_msg;
}

function suburbia_previewMayorMessage(%msg)
{
	%msg = strUpr(%msg);
	%msg = suburbia_formatEnterKey(%msg);
	
	for(%i = 0; %i <= 10; %i++)
		("SRB_Mayor_MP_row_" @ %i).setValue("<font:Lucida Console:23><color:ffffff>" @ getSubStr(%msg, (%i * 32), 32));
}

function clientCmdAddMayorBudgetHistory(%day, %text, %cost)
{
	addMayorBudgetRow(%day, %text, %cost);
}

function addMayorBudgetRow(%day, %text, %cost)
{
	%this = SRB_MayorBudgetList;
	
	if(%this.history_start $= "")
		%this.history_start = 0;
	
	if(%this.history_end $= "")
		%this.history_end = 0;
	
	%this.budget_history[%this.history_end] = %text;
	%this.budget_history[%this.history_end, "day"] = %day;
	%this.budget_history[%this.history_end, "cost"] = %cost;
	
	if(%this.history_end - %this.history_start > 25)
		%this.history_start++;
	
	%this.history_end++;
	
	displayMayorBudgetHistory();
}

function displayMayorBudgetHistory()
{
	%this = SRB_MayorBudgetList;
	%this.setText("");
	
	%last_date = "";
	%total_cost = "";
	
	for(%i = %this.history_end - 1; %i >= %this.history_start; %i--)
	{
		%date = %this.budget_history[%i, "day"];
		
		if(%date !$= %last_date)
		{
			if(%total_cost !$= "")
			{
				if(%total_cost > 0)
					SRB_MayorBudgetListTML_addRow2("\c5Total Money Spent: $" @ mAbs(%total_cost));
				else
					SRB_MayorBudgetListTML_addRow2("\c5Total Money Gained: $" @ mAbs(%total_cost));
			}
			
			if(%i != %this.history_end - 1)
				SRB_MayorBudgetListTML_addRow2("");
			
			SRB_MayorBudgetListTML_addRow2("\c4" @ %date);
			SRB_MayorBudgetListTML_addRow2("\c4-----------------------------------------------------------");
			%last_date = %date;
			
			%total_cost = 0;
		}
		
		%total_cost += %this.budget_history[%i, "cost"];
		
		SRB_MayorBudgetListTML_addRow2(%this.budget_history[%i]);
	}
	
	// displaying the total spent/gained for the last date
	if(%total_cost !$= "")
	{
		if(%total_cost > 0)
			SRB_MayorBudgetListTML_addRow2("\c5Total Money Spent: $" @ mAbs(%total_cost));
		else
			SRB_MayorBudgetListTML_addRow2("\c5Total Money Gained: $" @ mAbs(%total_cost));
	}
}

function SRB_MayorBudgetListTML_addRow2(%text)
{
	%this = SRB_MayorBudgetList;
	
	%text = "<lmargin:5>" @ %text;
	%text = strReplace(%text, "\c5", "<color:0000FF>");
	%text = strReplace(%text, "\c4", "<color:FF6060>");
	
	%this.setText(%this.getText() @ "<br><color:000000>" @ %text);
}

function clearMayorBudgetHistory()
{
	%this = SRB_MayorBudgetList;
	
	for(%i = 0; %i < %this.history_end; %i++)
	{
		%this.budget_history[%this.history_start] = "";
		%this.budget_history[%this.history_start, "day"] = "";
		%this.budget_history[%this.history_start, "cost"] = "";
	}
	
	%this.history_start = 0;
	%this.history_end = 0;
	
	displayMayorBudgetHistory();
}

function suburbia_takeGovMoney()
{
	Canvas.pushDialog("SRB_Mayor_TakeGovMoney");
}

function suburbia_sendTakeGovMoney()
{
	Canvas.popDialog("SRB_Mayor_TakeGovMoney");
	
	%val = mClamp(SRB_MayorTakeGovMoneyInput.getValue(), 0, 1000000);
	CommandToServer('MayorTakeGovMoney', %val);
}

function showLotterySettings()
{
	CommandToServer('MayorRequestLotteryUpdate');
	Canvas.pushDialog("SRB_Mayor_Lottery");
}

function clientCmdShowLotteryGui()
{
	showLotterySettings();
}

function suburbia_setLotteryPercent(%val)
{
	Suburbia_MayorLotteryText.setText("<just:center><color:ffff00><font:Calibri bold:26>Percentage: <color:ffffff>" @ mFloor(%val * 100) @ "%");
}

function suburbia_sendLotteryUpdate()
{
	SRB_MayorLotteryTicketsMax.setValue(mClamp(SRB_MayorLotteryTicketsMax.getValue(), 0, 100000));
	CommandToServer('MayorLotteryUpdate', SRB_MayorLotteryTicketsMax.getValue(), Suburbia_LotteryPercentageSlider.getValue());
}

function clientCmdUpdateLotteryValues(%percent, %money)
{
	SRB_MayorLotteryTicketsMax.setValue(%money);
	Suburbia_LotteryPercentageSlider.setValue(%percent);
	suburbia_setLotteryPercent(%percent);
}



function suburbia_viewMayorEmployees()
{
	clientCmdDisplayMayorJobList();
	Canvas.pushDialog(SRB_Mayor_Fire);
}

function clientCmdDisplayMayorJobList()
{
	SRB_MayorFireButton.visible = false;
	SRB_Mayor_FireWindow.extent = "327 343";
	
	displayMayorFireList();
}

function clientCmdClearMayorJobs()
{
	clearMayorJobList();
}

function clearMayorJobList()
{
	$Suburbia::Mayor::PoliceChief.clear();
	$Suburbia::Mayor::PoliceChief.row_count = 0;
	
	$Suburbia::Mayor::Psychologist.clear();
	$Suburbia::Mayor::Psychologist.row_count = 0;
}

function selectMayorJob()
{
	%id = SRB_MayorFireList.getSelectedId();
	%job = getField(SRB_MayorFireList.getRowTextById(%id), 1);
	
	if(%job !$= "")
	{
		SRB_MayorFireButton.visible = true;
		SRB_Mayor_FireWindow.extent = "327 383";
	}
	else
	{
		SRB_MayorFireButton.visible = false;
		SRB_Mayor_FireWindow.extent = "327 343";
	}
}

function displayMayorFireList()
{
	SRB_MayorFireList.clear();
	
	%list1 = $Suburbia::Mayor::PoliceChief;
	%list2 = $Suburbia::Mayor::Psychologist;
	// %list3 = $Suburbia::PoliceChief::Cadet;
	
	%list1.sort(0, true);
	%list2.sort(0, true);
	// %list3.sort(0, true);
	
	for(%i = 0; %i < %list1.row_count; %i++)
		SRB_MayorFireList.addRow(%i, "\c0" @ %list1.getRowTextById(%list1.getRowId(%i)) TAB "\c5Police Chief", %i + 3);
	
	for(%i = 0; %i < %list2.row_count; %i++)
		SRB_MayorFireList.addRow(%i + %list1.row_count, "\c0" @ %list2.getRowTextById(%list2.getRowId(%i)) TAB "\c5Psychologist", %i + 3 + %list1.row_count);
	
	// for(%i = 0; %i < %list3.row_count; %i++)
	// 	SRB_PCHireFireList.addRow(%i + %list1.row_count + %list2.row_count, "\c0" @ %list3.getRowTextById(%list3.getRowId(%i)) TAB "\c5      Cadet", %i + 3 + %list1.row_count + %list2.row_count);
	
	SRB_MayorFireList.addRow(-1, "", 0);
	SRB_MayorFireList.addRow(-1, "\c4Player Name\tPosition", 1);
	SRB_MayorFireList.addRow(-1, "\c4----------------------------------------------------------------------", 2);
}

if(!isObject($Suburbia::Mayor::PoliceChief))
{
	$Suburbia::Mayor::PoliceChief = new GuiTextListCtrl();
	$Suburbia::Mayor::PoliceChief.row_count = 0;
	
	$Suburbia::Mayor::Psychologist = new GuiTextListCtrl();
	$Suburbia::Mayor::Psychologist.row_count = 0;
}

function clientCmdAddMayorJob(%name, %position)
{
	if(%position $= "Police Chief")
	{
		$Suburbia::Mayor::PoliceChief.addRow($Suburbia::Mayor::PoliceChief.row_count, %name);
		$Suburbia::Mayor::PoliceChief.row_count++;
	}
	else if(%position $= "Psychologist")
	{
		$Suburbia::Mayor::Psychologist.addRow($Suburbia::Mayor::Psychologist.row_count, %name);
		$Suburbia::Mayor::Psychologist.row_count++;
	}
}

function mayorFire()
{
	%id = SRB_MayorFireList.getSelectedId();
	%name = strReplace(getField(SRB_MayorFireList.getRowTextById(%id), 0), "\c0", "");
	
	CommandToServer('MayorFire', %name);
}

DeactivatePackage(Client_Suburbia);
package Client_Suburbia
{
	function refreshCenterTextCtrl()
	{
		Parent::refreshCenterTextCtrl();
	}
	
	function CenterPrintText::onResize(%this, %width, %height)
	{
		if(isEventPending(SuburbiaClient.title_sch))
			%this.centerY();
		else
			Parent::onResize(%this, %width, %height);
	}
	
	function optionsDlg::setShaderQuality(%this, %level)
	{
		Parent::setShaderQuality(%this, %level);
		
		CommandToServer('ReceiveShaders', $Pref::ShaderQuality);
	}
	
	// since rtb isn't used on suburbia i can just steal its connect arg away when connecting to suburbia
	// function GameConnection::setConnectArgs(%a, %b, %c, %d, %e, %f, %rtb, %glass, %i, %j, %k, %l, %m, %n, %o, %p)
	// {
		// if(getSubStr($ServerInfo::Name, 0, 9) $= "Scenery's")
			// %glass = %glass SPC "suburbia";
		
		// Parent::setConnectArgs(%a, %b, %c, %d, %e, %f, %rtb, %glass, %i, %j, %k, %l, %m, %n, %o, %p);
	// }
	
	function disconnectedCleanup(%bool)
	{
		$Suburbia::HandshakeCompleted = false;
		
		ClientDropSound.fileName = "base/data/sound/playerLeave.wav";
		
		SuburbiaClient.showPlayGui();
		SuburbiaClient.delete();
		
		SuburbiaClient.deleteApplicantList();
		
		CreateSuburbiaClient();
		
		Parent::disconnectedCleanup(%bool);
	}
};
ActivatePackage(Client_Suburbia);

// copied from new duplicator because my handshake system doesn't work half the time for fuck knows why
function clientCmdSuburbiaHandshake()
{
	ClearLaws();
	SuburbiaClient.clearVehicles();
	ClearPCVS();
	ClearPCWS();
	CommandToServer('RequestLaws');
	CommandToServer('RequestNewscasters');
	CommandToServer('SetDefaultFOV', $Pref::Player::DefaultFov);
	
	ClientDropSound.fileName = "";
	
	$Suburbia::HandshakeCompleted = true;
	
	CommandToServer('CompleteSuburbiaHandshake', SuburbiaClient.version);
}

if(!isObject(SuburbiaEngineSoundDescription))
{
	new AudioDescription(SuburbiaEngineSoundDescription)
	{
		volume = "1";
		isLooping = "1";
		isStreaming = "0";
		is3D = "0";
		ReferenceDistance = "1";
		maxDistance = "100";
		coneInsideAngle = "360";
		coneOutsideAngle = "360";
		coneOutsideVolume = "1";
		coneVector = "0 0 1";
		environmentLevel = "0";
		loopCount = "-1";
		minLoopGap = "0";
		maxLoopGap = "0";
		type = "0";
	};
}

function suburbia_updateEngineLoop(%vehicle, %ghostId)
{
	if(!isObject($Suburbia::VehicleDatablock))
		findWheeledVehicleDatablock();
	
	cancel(%vehicle.engineUpdateSch);
	
	if(isObject(%vehicle))
	{
		if(%vehicle.ui_name $= "")
			%vehicle.ui_name = %vehicle.getDatablock().uiName;
		
		if(!$Suburbia::VehicleSoundData[%vehicle.ui_name, "sounds_set"])
			return;
	}
	
	if(!isObject(%vehicle) || %ghostId == -1 || %ghostId $= "")
	{
		alxStop($Suburbia::VehicleSound[%ghostId, "idle"]);
		alxStop($Suburbia::VehicleSound[%ghostId, "sample"]);
		alxStop($Suburbia::VehicleSound[%ghostId, "sample2"]);
	
		return;
	}
	
	if(%vehicle.getClassName() $= "WheeledVehicle")
	{
		%player_pos = ServerConnection.getControlObject().getPosition();
		%vehicle_pos = %vehicle.positionGet();
		
		if(VectorDist(%vehicle_pos, %player_pos) < 35)
		{
			if(!alxIsPlaying($Suburbia::VehicleSound[%ghostId, "idle"]))
			{
				alxStop($Suburbia::VehicleSound[%ghostId, "idle"]);
				alxStop($Suburbia::VehicleSound[%ghostId, "sample"]);
				alxStop($Suburbia::VehicleSound[%ghostId, "sample2"]);
				
				$Suburbia::VehicleSound[%ghostId, "idle"] = alxPlay($Suburbia::VehicleSoundData[%vehicle.ui_name, "idle"]);
				$Suburbia::VehicleSound[%ghostId, "sample"] = alxPlay($Suburbia::VehicleSoundData[%vehicle.ui_name, "sample"]);
				
				if($Suburbia::VehicleSoundData[%vehicle.ui_name, "sample2"] !$= "")
					$Suburbia::VehicleSound[%ghostId, "sample2"] = alxPlay($Suburbia::VehicleSoundData[%vehicle.ui_name, "sample2"]);
			}
		}
		else
		{
			if(alxIsPlaying($Suburbia::VehicleSound[%ghostId, "idle"]))
			{
				alxStop($Suburbia::VehicleSound[%ghostId, "idle"]);
				alxStop($Suburbia::VehicleSound[%ghostId, "sample"]);
				alxStop($Suburbia::VehicleSound[%ghostId, "sample2"]);
			}
		}
		
		%velocity = vectorLen(%vehicle.getVelocity());
		
		if(%vehicle.engineThrottle $= "")
		{
			%vehicle.engineThrottle = 1;
			%vehicle.movingForwards = true;
		}
		
		// %vehicle.movingForwards = true;
		
		if(%vehicle.engineThrottle > 200)
			%vehicle.engineThrottle = 0;
		
		if(%vehicle.speedLimit > 200)
			%vehicle.speedLimit = %velocity;
		
		%max = $Suburbia::VehicleSoundData[%vehicle.ui_name, "max_speed"] / 1.1;
		
		%time_mod = ($Suburbia::EngineSoundTime / 5);
		
		// calcualting acceleration n shit
		%vehicle.vehicleTick++;
		
		if((%vehicle.vehicleTick % 20) == 0)
		{
			%vehicle.speed2 = %vehicle.speed1;
			%vehicle.speed1 = %velocity;
		}
		
		%real_acceleration = (mAbs(%vehicle.speed1 - %vehicle.speed2) / (32 * %time_mod));
		%real_acceleration += $Suburbia::VehicleSoundData[%vehicle.ui_name, "accel"] * %time_mod;
		
		if(%vehicle.speedLimit == 0)
			%vehicle.speedLimit = %velocity;
		
		// calculating limit for speed n shit, if you hit a brick wall it makes a transition from 10000 rpm to 0 rpm really nicely
		%difference = (%vehicle.speedLimit > %velocity ? -1 : 1);
		%vehicle.speedLimit += %real_acceleration * $Suburbia::VehicleSoundData[%vehicle.ui_name, "real_accel"] * %difference * %time_mod;
		
		if((%vehicle_mount = ServerConnection.getControlObject().getObjectMount()) == %vehicle)
		{
			%vehicle_pos = ServerConnection.getControlObject().getPosition();
			%no_3d = true;
		}
		else
		{
			%vehicle_pos = %vehicle.positionGet();
			%vehicle_pos = VectorAdd(%vehicle_pos, VectorScale(VectorNormalize(%vehicle.getVelocity()), %velocity/8));
		}
		
		// checking to see if the client is actually driving the vehicle or not
		if(isObject(%vehicle_mount))
			if(ServerConnection.getControlObject().getObjectMount().getMountNodeObject(0) != ServerConnection.getControlObject())
				%vehicle_mount = 0;
	
		// if we're accelerating then we'll play engine sounds, if not, then play something else
		if($mvForwardAction > 0 || $mvBackwardAction > 0)
		{
			if(%vehicle_mount == %vehicle)
			{
				if(%vehicle.engineThrottleSet == false)
				{
					%vehicle.engineThrottleSet = true;
					%vehicle.engineThrottle = %vehicle.idleThrottle;
				}
				
				// the engine has to "switch direction" if we alternate from accelerating forwards to accelerating backwards, this fixes it
				if($mvForwardAction > 0 && $mvBackwardAction == 0)
				{
					if(%vehicle.movingBackwards)
						%vehicle.backwardsModifier = -1;
					
					if(%vehicle.backwardsModifier == -1 && (%vehicle.engineThrottle < 5 && %vehicle.engineThrottle > 0))
						%vehicle.backwardsModifier = 1;
					
					%vehicle.movingForwards = true;
					%vehicle.movingBackwards = false;
				}
				
				if($mvBackwardAction > 0 && $mvForwardAction == 0)
				{
					if(%vehicle.movingForwards && %vehicle.engineThrottle > 5)
						%vehicle.backwardsModifier = -1;
					
					if(%vehicle.backwardsModifier == -1 && (%vehicle.engineThrottle < 5 && %vehicle.engineThrottle > 0))
						%vehicle.backwardsModifier = 1;
						
					%vehicle.movingForwards = false;
					%vehicle.movingBackwards = true;
				}
				
				if($mvTriggerCount2)
					%acceleration = 4;
				else
					%acceleration = 1;
				
				if(%velocity < 10)
					%vehicle.backwardsModifier = 1;
				
				// the decelleration for switching between going forward and reversing is too slow, this fixes it
				if(%vehicle.backwardsModifier == -1)
				{
					if(%vehicle.engineThrottle - 2 < %velocity && %vehicle.engineThrottle + 2 > %vehicle.speedLimit)
						%vehicle.engineThrottle = mClampF(%velocity, 0, %vehicle.speedLimit);
					else if(%vehicle.engineThrottle > %velocity) // prevents strange glitch that stops the whole script from functioning right if you reverse and then come to a stop
						%vehicle.engineThrottle = mClampF(%vehicle.engineThrottle, 0, %vehicle.speedLimit);
					else
					{
						%vehicle.engineThrottle = mClampF(%vehicle.engineThrottle, 0, %vehicle.speedLimit);
						%acceleration = 2;
					}
				}
				else
					%vehicle.engineThrottle = mClampF(%vehicle.engineThrottle, 0, %vehicle.speedLimit);
			}
			else
				%vehicle.engineThrottle = %velocity;
			
			%throttle = %vehicle.engineThrottle / %max;
			%idle = mClampF(%vehicle.engineThrottle / 5, 0, 2);
			
			alxSourcef($Suburbia::VehicleSound[%ghostId, "idle"], "AL_REFERENCE_DISTANCE", 1 - %idle);
			alxSourcef($Suburbia::VehicleSound[%ghostId, "idle"], "AL_PITCH", (1 - %idle * 0.25) * getTimeScale());
			
			alxSourcef($Suburbia::VehicleSound[%ghostId, "sample"], "AL_REFERENCE_DISTANCE", %idle);
			alxSourcef($Suburbia::VehicleSound[%ghostId, "sample"], "AL_PITCH", (0.2 + %throttle) * getTimeScale());
			
			alxSourcef($Suburbia::VehicleSound[%ghostId, "sample2"], "AL_REFERENCE_DISTANCE", mAbs(%idle + - 0.5));
			alxSourcef($Suburbia::VehicleSound[%ghostId, "sample2"], "AL_PITCH", (0.2 + %throttle) * getTimeScale());
			
			// if we're outside the car
			if(%no_3d == false)
			{
				%player_pos = ServerConnection.getControlObject().getPosition();
				
				alxSourcef($Suburbia::VehicleSound[%ghostId, "idle"], "AL_GAIN", 0.6 * $Suburbia::EngineVolume);
				alxSourcef($Suburbia::VehicleSound[%ghostId, "sample"], "AL_GAIN", 0.6 * $Suburbia::EngineVolume);
				alxSourcef($Suburbia::VehicleSound[%ghostId, "sample2"], "AL_GAIN", 0.6 * $Suburbia::EngineVolume);
				
				%x = (getWord(%vehicle_pos, 0) - getWord(%player_pos, 0)) / 100;
				%y = (getWord(%player_pos, 1) - getWord(%vehicle_pos, 1)) / 100;
				%z = (getWord(%vehicle_pos, 2) - getWord(%player_pos, 2)) / 100;
				
				alxSource3f($Suburbia::VehicleSound[%ghostId, "idle"], "AL_POSITION", %x SPC %y SPC %z);
				alxSource3f($Suburbia::VehicleSound[%ghostId, "sample"], "AL_POSITION", %x SPC %y SPC %z);
				alxSource3f($Suburbia::VehicleSound[%ghostId, "sample2"], "AL_POSITION", %x SPC %y SPC %z);
			}
			// if we're inside the car
			else
			{
				alxSourcef($Suburbia::VehicleSound[%ghostId, "idle"], "AL_GAIN", (1 - (%throttle / 15)) * $Suburbia::EngineVolume);
				alxSourcef($Suburbia::VehicleSound[%ghostId, "sample"], "AL_GAIN", mClampF(1 - (1.0 - %idle), 0, 1) * $Suburbia::EngineVolume);
				alxSourcef($Suburbia::VehicleSound[%ghostId, "sample2"], "AL_GAIN", mClampF(1 - (1.0 - %idle), 0, 1) * $Suburbia::EngineVolume);
				
				alxSource3f($Suburbia::VehicleSound[%ghostId, "idle"], "AL_POSITION", "0 0 0.1");
				alxSource3f($Suburbia::VehicleSound[%ghostId, "sample"], "AL_POSITION", "0 0 0.1");
				alxSource3f($Suburbia::VehicleSound[%ghostId, "sample2"], "AL_POSITION", "0 0 0.1");
			}
			
			%vehicle.engineThrottle += %real_acceleration * %acceleration * %vehicle.backwardsModifier * %time_mod;
			%vehicle.idleThrottleSet = false;
		}
		else
		{
			if(%vehicle_mount == %vehicle)
			{
				if(%vehicle.idleThrottleSet == false)
				{
					%vehicle.idleThrottleSet = true;
					%vehicle.idleThrottle = %vehicle.engineThrottle;
				}
				
				if($mvTriggerCount2)
					%acceleration = 3;
				else
					%acceleration = 2;
				
				if(%vehicle.idleThrottle < 10)
					%vehicle.backwardsModifier = 1;
				
				%vehicle.idleThrottleLimit = mClamp(%velocity - $Suburbia::VehicleSoundData[%vehicle.ui_name, "idle_throttle_limit"], 0, %vehicle.speedLimit);
				%vehicle.idleThrottle = mClampF(%vehicle.idleThrottle, %vehicle.idleThrottleLimit, %vehicle.speedLimit);
			}
			else
				%vehicle.idleThrottle = %velocity;
			
			%throttle = %vehicle.idleThrottle / %max;
			%idle = mClampF(%vehicle.idleThrottle / 5, 0, 2);
			
			alxSourcef($Suburbia::VehicleSound[%ghostId, "idle"], "AL_REFERENCE_DISTANCE", 1 - %idle);
			alxSourcef($Suburbia::VehicleSound[%ghostId, "idle"], "AL_PITCH", ((1 - %idle * 0.25) * getTimeScale()));

			alxSourcef($Suburbia::VehicleSound[%ghostId, "sample"], "AL_REFERENCE_DISTANCE", %idle);
			alxSourcef($Suburbia::VehicleSound[%ghostId, "sample"], "AL_PITCH", ((0.2 + %throttle) * getTimeScale()));
			
			alxSourcef($Suburbia::VehicleSound[%ghostId, "sample2"], "AL_REFERENCE_DISTANCE", mAbs(%idle + - 0.5));
			alxSourcef($Suburbia::VehicleSound[%ghostId, "sample2"], "AL_PITCH", (0.2 + %throttle) * getTimeScale());
			
			if(%no_3d == false)
			{
				%player_pos = ServerConnection.getControlObject().getPosition();
				
				alxSourcef($Suburbia::VehicleSound[%ghostId, "idle"], "AL_GAIN", 0.6 * $Suburbia::EngineVolume);
				alxSourcef($Suburbia::VehicleSound[%ghostId, "sample"], "AL_GAIN", 0.6 * $Suburbia::EngineVolume);
				alxSourcef($Suburbia::VehicleSound[%ghostId, "sample2"], "AL_GAIN", 0.6 * $Suburbia::EngineVolume);
				
				%x = (getWord(%vehicle_pos, 0) - getWord(%player_pos, 0)) / 100;
				%y = (getWord(%player_pos, 1) - getWord(%vehicle_pos, 1)) / 100;
				%z = (getWord(%vehicle_pos, 2) - getWord(%player_pos, 2)) / 100;
				
				alxSource3f($Suburbia::VehicleSound[%ghostId, "idle"], "AL_POSITION", %x SPC %y SPC %z);
				alxSource3f($Suburbia::VehicleSound[%ghostId, "sample"], "AL_POSITION", %x SPC %y SPC %z);
				alxSource3f($Suburbia::VehicleSound[%ghostId, "sample2"], "AL_POSITION", %x SPC %y SPC %z);
			}
			else
			{
				alxSourcef($Suburbia::VehicleSound[%ghostId, "idle"], "AL_GAIN", (1 - (%throttle / 15)) * $Suburbia::EngineVolume);
				alxSourcef($Suburbia::VehicleSound[%ghostId, "sample"], "AL_GAIN", mClampF(1 - (1.0 - %idle), 0, 1) * $Suburbia::EngineVolume);
				alxSourcef($Suburbia::VehicleSound[%ghostId, "sample2"], "AL_GAIN", mClampF(1 - (1.0 - %idle), 0, 1) * $Suburbia::EngineVolume);
				
				alxSource3f($Suburbia::VehicleSound[%ghostId, "idle"], "AL_POSITION", "0 0 0.1");
				alxSource3f($Suburbia::VehicleSound[%ghostId, "sample"], "AL_POSITION", "0 0 0.1");
				alxSource3f($Suburbia::VehicleSound[%ghostId, "sample2"], "AL_POSITION", "0 0 0.1");
			}
			
			%vehicle.idleThrottle -= $Suburbia::VehicleSoundData[%vehicle.ui_name, "idle_accel"] * %acceleration * %time_mod;
			%vehicle.engineThrottleSet = false;
		}
	}

	%vehicle.engineUpdateSch = schedule($Suburbia::EngineSoundTime, 0, suburbia_updateEngineLoop, %vehicle, %ghostId);
}

function setEngineVolume(%volume)
{
	$Suburbia::EngineVolume = (%volume * OptAudioVolumeMaster.getValue());
}

schedule(30000, 0, setEngineVolume, 0.4);
$Suburbia::EngineSoundTime = 5;

// i can't package soemthing like WheeledVehicle::onAdd, so this is my alternative. yes, its incredibly ugly and i hope to find an alternative
function clientCmdVehicleSpawned(%ghostId, %override_name)
{
	if(alxIsPlaying($Suburbia::VehicleSound[%ghostId, "idle"]))
		return;
	
	// echo("playing" SPC %override_name SPC "set name" SPC ServerConnection.resolveGhostId(%ghostId).ui_name);
	
	ServerConnection.resolveGhostId(%ghostId).ui_name = %override_name;
	
	suburbia_updateEngineLoop(ServerConnection.resolveGhostId(%ghostId), %ghostId);
}

function clientCmdSetEngineSounds(%fields)
{
	%ui_name = getField(%fields, 0);
	%accel_mod = getField(%fields, 1);
	%real_accel_mod = getField(%fields, 2);
	%idle_throttle_limit = getField(%fields, 3);
	%idle_accel = getField(%fields, 4);
	%max_speed = getField(%fields, 5);
	
	%idle_sound = getField(%fields, 6);
	%sample_sound = getField(%fields, 7);
	
	if(getFieldCount(%fields) == 9)
		%sample2_sound = getField(%fields, 8);
	else
		%sample2_sound = "";
	
	// stuff for acceleration and whatnot
	$Suburbia::VehicleSoundData[%ui_name, "accel"] = %accel_mod;
	$Suburbia::VehicleSoundData[%ui_name, "real_accel"] = %real_accel_mod;
	$Suburbia::VehicleSoundData[%ui_name, "idle_throttle_limit"] = %idle_throttle_limit;
	$Suburbia::VehicleSoundData[%ui_name, "idle_accel"] = %idle_accel;
	$Suburbia::VehicleSoundData[%ui_name, "max_speed"] = %max_speed;
	
	
	
	// sounds
	$Suburbia::VehicleSoundData[%ui_name, "idle"] = "Suburbia" @ %idle_sound @ "Sound";
	$Suburbia::VehicleSoundData[%ui_name, "sample"] = "Suburbia" @ %sample_sound @ "Sound";
	
	createSound(%idle_sound);
	createSound(%sample_sound);
	
	if(%sample2_sound !$= "")
	{
		$Suburbia::VehicleSoundData[%ui_name, "sample2"] = "Suburbia" @ %sample2_sound @ "Sound";
		createSound(%sample2_sound);
	}
	else
		$Suburbia::VehicleSoundData[%ui_name, "sample2"] = "";
	
	$Suburbia::VehicleSoundData[%ui_name, "sounds_set"] = true;
	
	// echo("clientCmdSetEngineSounds() >> ENGINE SOUNDS SET FOR '" @ %ui_name @ "':");
	// echo("   'accel' => '" @ $Suburbia::VehicleSoundData[%ui_name, "accel"] @ "'");
	// echo("   'real_accel' => '" @ $Suburbia::VehicleSoundData[%ui_name, "real_accel"] @ "'");
	// echo("   'idle_throttle_limit' => '" @ $Suburbia::VehicleSoundData[%ui_name, "idle_throttle_limit"] @ "'");
	// echo("   'idle_accel' => '" @ $Suburbia::VehicleSoundData[%ui_name, "idle_accel"] @ "'");
	// echo("   'max_speed' => '" @ $Suburbia::VehicleSoundData[%ui_name, "max_speed"] @ "'");
	
	// echo("   'idle' => '" @ $Suburbia::VehicleSoundData[%ui_name, "idle"] @ "'");
	// echo("   'sample' => '" @ $Suburbia::VehicleSoundData[%ui_name, "sample"] @ "'");
	
	// if(%sample2_sound !$= "")
	// 	echo("   'sample2' => '" @ $Suburbia::VehicleSoundData[%ui_name, "sample2"] @ "'");
}

if(!isObject(Suburbia_EngineSoundGroup))
	new ScriptGroup(Suburbia_EngineSoundGroup);

function createSound(%name)
{
	%sound = new AudioProfile("Suburbia" @ %name @ "Sound")
	{
		description = SuburbiaEngineSoundDescription;
		fileName = "./sounds/" @ %name @ ".wav";
	};
	Suburbia_EngineSoundGroup.add(%sound);
}

function findWheeledVehicleDatablock()
{
	for(%i = 0; %i < 15000; %i++)
	{
		if(isObject(%i))
		{
			if(%i.getClassName() $= "WheeledVehicleData")
			{
				$Suburbia::VehicleDatablock = %i;
				break;
			}
		}
	}
}

// i know you fixed this for players badspot but sending vehicle position over serverCmd doesn't sound like the most efficent thing on the planet and doing it all client-sided is a lot better than serverCmds
function WheeledVehicle::positionGet(%this)
{
	%name = %this.getname();
	%this.setName("temp2");
	eval("%obj = new " @ %this.getclassname() @ "(temp : temp2){datablock = " @ $Suburbia::VehicleDatablock @ ";};");
	%result = %obj.position;
	%this.setname(%name);
	%obj.delete();
	return %result;
}

function WheeledVehicle::rotationGet(%this)
{
	%name = %this.getname();
	%this.setName("temp2");
	eval("%obj = new " @ %this.getclassname() @ "(temp : temp2){datablock = " @ $Suburbia::VehicleDatablock @ ";};");
	%result = %obj.rotation;
	%this.setname(%name);
	%obj.delete();
	return %result;
}

function Camera::getAngleAway(%this, %targPos)
{
	return Player::getAngleAway(%this, %targPos);
}

function Player::getAngleAway(%this, %targPos)
{
	%fv = %this.getForwardVector();
	
	%xA = getWord(%fv, 0);
	%yA = getWord(%fv, 1);
	
	%nv = VectorNormalize(VectorSub(%targPos, %this.getPosition()));
	
	%xB = getWord(%nv, 0);
	%yB = getWord(%nv, 1);
	
	%rad = mAbs(mATan(%xA, %yA) - mATan(%xB, %yB));
	
	if(%rad > $pi)
		%rad = (2 * $pi) - %rad;
	
	%deg = (180 / $PI) * %rad;
	
	return %deg;
}

function vectorAngleBetween(%vec1, %vec2)
{ 
	//Returns the angle between two vectors in radians
	return mACos(vectorDot(%vec1, %vec2)/(vectorLen(%vec1) * vectorLen(%vec2)));
}














function discoverVehicles()
{
	%count = 0;
	for(%i = 0; %i < 100000; %i++)
	{
		if(isObject(%i))
		{
			if(%i.getClassName() $= "WheeledVehicleData")
			{
				// $Suburbia::VehicleDatablock = %i;
				if(%i.uiName !$= "")
				{
					// echo("found:" SPC %i.uiName);
					$Suburbia::VehicleDatablock[%count] = %i.uiName;
					%count++;
				}
			}
		}
	}
	$Suburbia::VehicleDatablockTotal = %count;
}

function screenshotLoop(%count)
{
	setFov(35);
	CommandToServer('MessageSent', "$_26879_vehicleSpawn_543.setVehicle($uiNameTable_Vehicle[\"" @ $Suburbia::VehicleDatablock[%count] @ "\"]);");
	
	schedule(3000, 0, screenshot, "screenshots/vehicles/" @ getSafeVariableName($Suburbia::VehicleDatablock[%count]) @ ".png", "png", false);
	
	if($Suburbia::VehicleDatablockTotal == %count)
		return;
	
	$Suburbia::ScreenshotSch = schedule(3500, 0, screenshotLoop, %count + 1);
}




function testAccelerationLoop(%count)
{
	CommandToServer('MessageSent', "$_26879_vehicleSpawn_545.setVehicle($uiNameTable_Vehicle[\"" @ $Suburbia::VehicleDatablock[%count] @ "\"]);");
	schedule(150, 0, CommandToServer, 'MessageSent', "$_26879_vehicleSpawn_545.vehicle.mountObject(%obj, 0);");
	jump(false);
	schedule(700, 0, startAccelerationTimer, $Suburbia::VehicleDatablock[%count]);
	
	if($Suburbia::VehicleDatablockTotal == %count)
		return;
	
	$Suburbia::AccelerationSch = schedule(3000, 0, testAccelerationLoop, %count + 1);
}

function startAccelerationTimer(%vehicle_name)
{
	jump(false);
	moveforward(1);
	$start_pos = ServerConnection.getControlobject().getObjectMount().positionGet();
	
	schedule(2000, 0, stopAccelerationTimer, %vehicle_name);
}

function stopAccelerationTimer(%vehicle_name)
{
	jump(true);
	moveforward(0);
	
	// $City::Vehicles::Acceleration[%vehicle_name] = VectorDist($start_pos, ServerConnection.getControlObject().getObjectMount().positionGet()) / 2;
	%thing = "$City::Vehicles::Acceleration[\"" @ %vehicle_name @ "\"] = " @ VectorDist($start_pos, ServerConnection.getControlObject().getObjectMount().positionGet()) / 2 @ ";";
	%file = new FileObject();
	%file.openForAppend("config/acceleration.cs");
	%file.writeLine(%thing);
	%file.close();
	%file.delete();
	
	// echo(VectorDist($start_pos, ServerConnection.getControlObject().getObjectMount().positionGet()) / 2 SPC "tu/s\xB2");
	setClipboard(VectorDist($start_pos, ServerConnection.getControlObject().getObjectMount().positionGet()) / 2 SPC "tu/s\xB2");
}




function testBrakeLoop(%count)
{
	CommandToServer('MessageSent', "$_26879_vehicleSpawn_545.setVehicle($uiNameTable_Vehicle[\"" @ $Suburbia::VehicleDatablock[%count] @ "\"]);");
	schedule(150, 0, CommandToServer, 'MessageSent', "$_26879_vehicleSpawn_545.vehicle.mountObject(%obj, 0);");
	jump(false);
	schedule(200, 0, moveforward, 1);
	schedule(6000, 0, startBrakeTimer, $Suburbia::VehicleDatablock[%count]);
	
	if($Suburbia::VehicleDatablockTotal == %count)
		return;
	
	$Suburbia::BrakeSch = schedule(9500, 0, testBrakeLoop, %count + 1);
}

function startBrakeTimer(%vehicle_name)
{
	jump(true);
	moveforward(0);
	$start_pos = ServerConnection.getControlobject().getObjectMount().positionGet();
	
	schedule(2000, 0, stopBrakeTimer, %vehicle_name);
}

function stopBrakeTimer(%vehicle_name)
{
	jump(false);
	
	// $City::Vehicles::Acceleration[%vehicle_name] = VectorDist($start_pos, ServerConnection.getControlObject().getObjectMount().positionGet()) / 2;
	%thing = "$City::Vehicles::Brakes[\"" @ %vehicle_name @ "\"] = " @ VectorDist($start_pos, ServerConnection.getControlObject().getObjectMount().positionGet()) / 2 @ ";";
	%file = new FileObject();
	%file.openForAppend("config/brakes.cs");
	%file.writeLine(%thing);
	%file.close();
	%file.delete();
	
	// echo(VectorDist($start_pos, ServerConnection.getControlObject().getObjectMount().positionGet()) / 2 SPC "tu");
	setClipboard(VectorDist($start_pos, ServerConnection.getControlObject().getObjectMount().positionGet()) / 2 SPC "tu");
}