function loadSuburbiaHelp()
{
	if(SRB_HelpList.rowCount() > 20)
	 	return;
	
	SRB_HelpList.clear();
	
	for(%i = findFirstFile("Add-Ons/Client_Suburbia/gui/help/*.txt"); %i !$= ""; %i = findNextFile("Add-Ons/Client_Suburbia/gui/help/*.txt"))
		SRB_HelpList.addRow(SRB_HelpList.rowCount() + 1, fileBase(%i) @ "                                                         ", 1);
	
	SRB_HelpList.sort(0, true);
	// SRB_HelpList.addRow(0, "", 0);
	
	SRB_HelpList.extent = 2000 SPC getWord(SRB_HelpList.extent, 1);
	SRB_Help_Swatch.extent = 2000 SPC getWord(SRB_HelpList.extent, 1) + 7;
}

function loadDictionaryFile(%name)
{
	%name = trim(%name);
	
	if(!isFile("Add-Ons/Client_Suburbia/gui/help/" @ %name @ ".txt"))
	{
		SRB_HelpText.setText("");
		return;
	}
	
	%file = new FileObject();
	%file.openForRead("Add-Ons/Client_Suburbia/gui/help/" @ %name @ ".txt");
	
	SRB_HelpText.setText("<lmargin:5><font:Arial:5><br><font:Arial:14>");
	
	while(!%file.isEOF())
	{
		%line = %file.readLine();
		SRB_HelpText.setText(SRB_HelpText.getText() @ %line);
	}
	
	%file.close();
	%file.delete();
}