// things police gui needs:
// 
// employee managmenet
// budget display
// vehicle managmenet
// weapon managment


// if police chief kills the mayor police chief instantly becomes mayor

function showPoliceChiefMainGui()
{
	Canvas.schedule(1, pushDialog, SRB_PoliceChief_Main);
}

function clientCmdShowPoliceChiefMainGui()
{
	showPoliceChiefMainGui();
}

function clientCmdPoliceChiefJobsList()
{
	displayPCHireFireList();
}

function displayPCHireFireList()
{
	SRB_PCHireFireList.clear();
	
	%list1 = $Suburbia::PoliceChief::Applicant;
	%list2 = $Suburbia::PoliceChief::Officer;
	%list3 = $Suburbia::PoliceChief::Cadet;
	
	%list1.sort(0, true);
	%list2.sort(0, true);
	%list3.sort(0, true);
	
	for(%i = 0; %i < %list1.row_count; %i++)
		SRB_PCHireFireList.addRow(%i, "\c0" @ %list1.getRowTextById(%list1.getRowId(%i)) TAB "\c5Applicant", %i + 3);
	
	for(%i = 0; %i < %list2.row_count; %i++)
		SRB_PCHireFireList.addRow(%i + %list1.row_count, "\c0" @ %list2.getRowTextById(%list2.getRowId(%i)) TAB "\c5    Officer", %i + 3 + %list1.row_count);
	
	for(%i = 0; %i < %list3.row_count; %i++)
		SRB_PCHireFireList.addRow(%i + %list1.row_count + %list2.row_count, "\c0" @ %list3.getRowTextById(%list3.getRowId(%i)) TAB "\c5      Cadet", %i + 3 + %list1.row_count + %list2.row_count);
	
	SRB_PCHireFireList.addRow(-1, "", 0);
	SRB_PCHireFireList.addRow(-1, "\c4Player Name\t  Position", 1);
	SRB_PCHireFireList.addRow(-1, "\c4----------------------------------------------------------------------", 2);
}

if(!isObject($Suburbia::PoliceChief::Applicant))
{
	$Suburbia::PoliceChief::Applicant = new GuiTextListCtrl();
	$Suburbia::PoliceChief::Applicant.row_count = 0;
	
	$Suburbia::PoliceChief::Officer = new GuiTextListCtrl();
	$Suburbia::PoliceChief::Officer.row_count = 0;
	
	$Suburbia::PoliceChief::Cadet = new GuiTextListCtrl();
	$Suburbia::PoliceChief::Cadet.row_count = 0;
}

function clientCmdAddPoliceApplicant(%name)
{
	$Suburbia::PoliceChief::Applicant.addRow($Suburbia::PoliceChief::Applicant.row_count, %name);
	$Suburbia::PoliceChief::Applicant.row_count++;
}

function clientCmdAddPoliceChiefJob(%name, %position)
{
	if(%position $= "Officer")
	{
		$Suburbia::PoliceChief::Officer.addRow($Suburbia::PoliceChief::Officer.row_count, %name);
		$Suburbia::PoliceChief::Officer.row_count++;
	}
	else if(%position $= "Cadet")
	{
		$Suburbia::PoliceChief::Cadet.addRow($Suburbia::PoliceChief::Cadet.row_count, %name);
		$Suburbia::PoliceChief::Cadet.row_count++;
	}
}

function clientCmdClearPoliceChiefJobs()
{
	clearPCJobList();
}

function clearPCJobList()
{
	$Suburbia::PoliceChief::Applicant.clear();
	$Suburbia::PoliceChief::Applicant.row_count = 0;
	
	$Suburbia::PoliceChief::Officer.clear();
	$Suburbia::PoliceChief::Officer.row_count = 0;
	
	$Suburbia::PoliceChief::Cadet.clear();
	$Suburbia::PoliceChief::Cadet.row_count = 0;
}

function selectPCJob()
{
	%id = SRB_PCHireFireList.getSelectedId();
	%job = getField(SRB_PCHireFireList.getRowTextById(%id), 1);
	
	if(%job $= "\c5Applicant")
	{
		SRB_PCAcceptCadetButton.visible = true;
		SRB_PCAcceptOfficerButton.visible = true;
		SRB_PCDenyJobButton.visible = true;
		
		SRB_PCFireButton.visible = false;
		SRB_PCDemoteOrPremoteButton.visible = false;
		
		SRB_PC_HireFireWindow.extent = "327 423";
	}
	else if(%job $= "\c5    Officer")
	{
		SRB_PCAcceptCadetButton.visible = false;
		SRB_PCAcceptOfficerButton.visible = false;
		SRB_PCDenyJobButton.visible = false;
		
		SRB_PCFireButton.visible = true;
		SRB_PCDemoteOrPremoteButton.visible = true;
		SRB_PCDemoteOrPremoteButton.setText("Demote to Cadet");
		
		SRB_PC_HireFireWindow.extent = "327 383";
	}
	else if(%job $= "\c5      Cadet")
	{
		SRB_PCAcceptCadetButton.visible = false;
		SRB_PCAcceptOfficerButton.visible = false;
		SRB_PCDenyJobButton.visible = false;
		
		SRB_PCFireButton.visible = true;
		SRB_PCDemoteOrPremoteButton.visible = true;
		SRB_PCDemoteOrPremoteButton.setText("Premote to Officer");
		
		SRB_PC_HireFireWindow.extent = "327 383";
	}
	else
	{
		SRB_PCAcceptCadetButton.visible = false;
		SRB_PCAcceptOfficerButton.visible = false;
		SRB_PCDenyJobButton.visible = false;
		
		SRB_PCFireButton.visible = false;
		SRB_PCDemoteOrPremoteButton.visible = false;
		
		SRB_PC_HireFireWindow.extent = "327 344";
	}
}

function pcFire()
{
	%id = SRB_PCHireFireList.getSelectedId();
	%name = strReplace(getField(SRB_PCHireFireList.getRowTextById(%id), 0), "\c0", "");

	CommandToServer('PoliceChiefFire', %name);
}

function pcDemoteOrPremote()
{
	%id = SRB_PCHireFireList.getSelectedId();
	%name = strReplace(getField(SRB_PCHireFireList.getRowTextById(%id), 0), "\c0", "");
	
	CommandToServer('PoliceChiefDemoteOrPremote', %name);
}

function pcHireOfficer()
{
	%id = SRB_PCHireFireList.getSelectedId();
	%name = strReplace(getField(SRB_PCHireFireList.getRowTextById(%id), 0), "\c0", "");
	
	CommandToServer('PoliceChiefHireOfficer', %name);
}
	
function pcHireCadet()
{
	%id = SRB_PCHireFireList.getSelectedId();
	%name = strReplace(getField(SRB_PCHireFireList.getRowTextById(%id), 0), "\c0", "");

	CommandToServer('PoliceChiefHireCadet', %name);
}

function pcDeny()
{
	%id = SRB_PCHireFireList.getSelectedId();
	%name = strReplace(getField(SRB_PCHireFireList.getRowTextById(%id), 0), "\c0", "");

	CommandToServer('PoliceChiefDeny', %name);
}






function pcSetOfficerPaycheck(%val)
{
	SRB_PCOfficerPaycheckText.setText("<just:center><color:ffff00><font:Calibri:26>Paycheck: <color:00cc00>$" @ mFloor(%val * 50));
}

function pcSetCadetPaycheck(%val)
{
	SRB_PCCadetPaycheckText.setText("<just:center><color:ffff00><font:Calibri:26>Paycheck: <color:00cc00>$" @ mFloor(%val * 50));
}

function clientCmdSetPolicePaychecks(%police, %cadet)
{
	SRB_PCOfficerPaycheckText.setText("<just:center><color:ffff00><font:Calibri:26>Paycheck: <color:00cc00>$" @ %police);
	SRB_PCOfficerPaycheckSlider.setValue(%police / 50);
	
	SRB_PCCadetPaycheckText.setText("<just:center><color:ffff00><font:Calibri:26>Paycheck: <color:00cc00>$" @ %cadet);
	SRB_PCCadetPaycheckSlider.setValue(%cadet / 50);
}

function pcApplyPaychecks()
{
	CommandToServer('PoliceChiefSetPaychecks', mFloor(SRB_PCOfficerPaycheckSlider.getValue() * 50), mFloor(SRB_PCCadetPaycheckSlider.getValue() * 50));
}






function showPCWSGui()
{
	if(!$Suburbia::PoliceOfficerWeaponsDisplayed)
		displayPCWS();
	
	resetSelectedPCWSIcon();
	Canvas.schedule(1, pushDialog, SRB_PoliceChief_WS);
}

function createPCWSIcon(%name, %icon_file, %position)
{
	%gui_name = "SRB_PCWSIcon_" @ %name;
	
	%icon = new GuiSwatchCtrl(%gui_name)
	{
		clipToParent = 1;
		color = "0 0 0 255";
		enabled = 1;
		extent = "98 116";
		horizSizing = "right";
		minExtent = "1 1";
		position = %position;
		profile = "GuiDefaultProfile";
		vertSizing = "bottom";
		visible = 1;
		
		new GuiSwatchCtrl()
		{
			clipToParent = 1;
			color = "235 235 235 255";
			enabled = 1;
			position = "2 2";
			extent = "94 94";
			horizSizing = "right";
			minExtent = "1 1";
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = 1;
		};
		
		new GuiBitmapCtrl()
		{
			alignLeft = false;
			alignTop = false;
			bitmap = %icon_file;
			clipToParent = true;
			enabled = true;
			extent = "78 78";
			horizSizing = "right";
			keepCached = false;
			lockAspectRatio = false;
			mColor = "255 255 255 255";
			minExtent = "1 1";
			mMultiply = false;
			overflowImage = false;
			position = "9 9";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = true;
			wrap = false;
		};
		
		new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "ServerListProfile";
			selectable = true;
			text = "<color:ffffff><just:center><font:Arial:14>" @ %name;
			caption = %name;
			vertSizing = "bottom";
			visible = true;
		};
		
		new GuiSwatchCtrl()
		{
			clipToParent = 1;
			color = "0 0 0 0";
			enabled = 1;
			position = "0 0";
			extent = "98 116";
			horizSizing = "right";
			minExtent = "1 1";
			position = "0 0";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = 1;
		};
		
		new GuiSwatchCtrl()
		{
			clipToParent = 1;
			color = "0 0 0 0";
			enabled = 1;
			position = "2 2";
			extent = "94 94";
			horizSizing = "right";
			minExtent = "1 1";
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = 1;
		};
		
		new GuiMouseEventCtrl(SRB_PCWSIconMouse)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "98 116";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
		};
	};
	Suburbia_PCWSScrollBackground.add(%icon);
	%icon.position = %position;
	
	%icon.background_bitmap = %icon.getObject(0);
	%icon.icon_image = %icon.getObject(1);
	%icon.icon_caption = %icon.getObject(2);
	%icon.white_tint = %icon.getObject(3);
	%icon.yellow_tint = %icon.getObject(4);
	%icon.icon_mouseCtrl = %icon.getObject(5);
	
	%icon.original_position = %position;
	
	%icon.weapon_name = %real_name;
	
	return %gui_name;
}

function addPCWSIcon(%name, %icon_file)
{
	if(Suburbia_PCWSScroll.suburbia_currentRow $= "")
		Suburbia_PCWSScroll.suburbia_currentRow = 1;
	
	// calculate the height that we should be at
	%current_row = Suburbia_PCWSScroll.suburbia_currentRow;
	%height = (((%current_row - 1) * 116) + (%current_row * 5));
	
	// determine where along the x axis we should place the icon
	if(Suburbia_PCWSScroll.suburbia_row[%current_row, "slot"] $= "")
		Suburbia_PCWSScroll.suburbia_row[%current_row, "slot"] = 1;
	
	%current_slot = Suburbia_PCWSScroll.suburbia_row[%current_row, "slot"];
	%width = (((%current_slot - 1) * 98) + (%current_slot * 5));
	
	// create the gui and file the icon under an array all at the same time
	%icon = Suburbia_PCWSScroll.suburbia_row[%current_slot, Suburbia_PCWSScroll.suburbia_row[%current_row, "slot"]] = createPCWSIcon(%name, %icon_file, %width SPC %height);
	
	// if we have too many icons on one row, increment the total row count so next time we start on a new row
	if(Suburbia_PCWSScroll.suburbia_row[%current_row, "slot"] == 3)
		Suburbia_PCWSScroll.suburbia_currentRow++;
	else
		Suburbia_PCWSScroll.suburbia_row[%current_row, "slot"]++;
		
	// resizing the background so that the scroll works right
	%background_height = (%current_row * 116) + ((%current_row + 1) * 5);
	
	if(%background_height < 292)
		%background_height = 292;
	
	Suburbia_PCWSScrollBackground.resize(1, 1, 315, %background_height);
	
	return %icon;
}

function SRB_PCWSIconMouse::onMouseDown(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.setMouseDown();
}

function SRB_PCWSIconMouse::onMouseUp(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	if(%this.mouseDown)
		%this.setSelectColors();
}

function SRB_PCWSIconMouse::onMouseEnter(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.setHoverColors();
}

function SRB_PCWSIconMouse::onMouseLeave(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.resetHoverColors();
	
	%scroll = %this.getGroup().getGroup();
	if(%this.mouseDown == true && %this.isSelected == false && %scroll.currently_selected == %this)
		%this.resetSelectColors();
	
	if(%this.mouseDown == true)
		%this.resetMouseDown();
	
	%this.mouseDown = false;
}

function SRB_PCWSIconMouse::setHoverColors(%this)
{
	%this.getGroup().white_tint.setColor("255 255 255 90");
	
	%this.hoverActive = true;
}

function SRB_PCWSIconMouse::resetHoverColors(%this)
{
	%this.getGroup().white_tint.setColor("0 0 0 0");
	
	%this.hoverActive = false;
}

function SRB_PCWSIconMouse::setSelectColors(%this)
{
	%this.resetMouseDown();
	%parent = %this.getGroup();
	
	%parent.yellow_tint.setColor("255 255 0 115");
	%parent.icon_caption.setValue("<color:FFFF00><just:center><font:Arial:14>" @ %parent.icon_caption.caption);
	
	%scroll = %parent.getGroup();
	if(isObject(%scroll.currently_selected) && %scroll.currently_selected != %this)
		%scroll.currently_selected.resetSelectColors();
	
	// set the description shit
	%cost = $Suburbia::PoliceChiefWeaponData[%parent.weapon_name, "cost"];
	if(%cost $= "")
		%cost = 0;
	
	SRB_PCWS1_Button.setText("Add for $" @ %cost SPC "(+" SPC SuburbiaClient.getInflationDifference(%cost) @ ")");
	
	%scroll.currently_selected = %this;
	%this.isSelected = true;
}

function SRB_PCWSIconMouse::resetSelectColors(%this)
{
	%this.getGroup().yellow_tint.setColor("0 0 0 0");
	%this.getGroup().icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:14>" @ %this.getGroup().icon_caption.caption);
	
	%scroll = %this.getGroup().getGroup();
	if(isObject(%scroll.currently_selected) && %scroll.currently_selected != %this)
		%scroll.currently_selected.resetSelectColors();
	
	%scroll.currently_selected = "";
	
	%this.isSelected = false;
}

function SRB_PCWSIconMouse::setMouseDown(%this)
{
	%parent = %this.getGroup();
	
	if(%parent.original_position $= "")
		%parent.original_position = %parent.position;
	
	%position = %parent.original_position;
	%parent.resize(getWord(%position, 0) + 2, getWord(%position, 1) + 2, 94, 112);
	
	if(!%this.isSelected)
		%parent.icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:12>" @ %this.getGroup().icon_caption.caption);
	else
		%parent.icon_caption.setValue("<color:FFFF00><just:center><font:Arial:12>" @ %this.getGroup().icon_caption.caption);
	
	%parent.icon_caption.resize(0, 96, 92, 20);
	
	%parent.background_bitmap.resize(2, 2, 90, 90);
	%parent.icon_image.resize(2, 2, 74, 74);
	%parent.yellow_tint.resize(2, 2, 90, 90);
	
	%parent.icon_image.position = "9 9";
	
	%this.mouseDown = true;
}

function SRB_PCWSIconMouse::resetMouseDown(%this)
{
	%parent = %this.getGroup();
	
	%position = %parent.original_position;
	%parent.resize(getWord(%position, 0), getWord(%position, 1), 98, 116);
	
	%parent.icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:14>" @ %this.getGroup().icon_caption.caption);
	%parent.icon_caption.resize(0, 99, 96, 20);
	
	%parent.background_bitmap.resize(2, 2, 94, 94);
	%parent.icon_image.resize(2, 2, 78, 78);
	%parent.yellow_tint.resize(2, 2, 94, 94);
	
	%parent.icon_image.position = "9 9";
	
	%this.mouseDown = false;
}

function clearPCWSScrollList()
{
	%count = getTaggedFieldCount(Suburbia_PCWSScroll);
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%field = Suburbia_PCWSScroll.getTaggedField(%i);
		%field_name = expandEscape(getField(%field, 0));
		eval("Suburbia_PCWSScroll." @ %field_name @ " = \"\";");
	}
	
	%count = Suburbia_PCWSScrollBackground.getCount();
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%obj = Suburbia_PCWSScrollBackground.getObject(%i);
		
		if(isObject(%obj))
			%obj.delete();
	}
}

function clearPCWS()
{
	$Suburbia::PCWeaponSelectDisplayed = false;
	DeleteVariables("$Suburbia::PoliceChiefWeaponData*");
	clearPCWSScrollList();
	$Suburbia::PCWSDisplayed = false;
}

function clientCmdAddPoliceChiefWeapon(%name, %cost, %icon_file)
{
	if($Suburbia::PoliceChiefWeaponDataCount $= "")
		$Suburbia::PoliceChiefWeaponDataCount = 0;
	
	$Suburbia::PoliceChiefWeaponData[$Suburbia::PoliceChiefWeaponDataCount] = %name;
	$Suburbia::PoliceChiefWeaponData[%name, "cost"] = %cost;
	$Suburbia::PoliceChiefWeaponData[%name, "icon"] = %icon_file;
	
	$Suburbia::PoliceChiefWeaponDataCount++;
}

function resetSelectedPCWSIcon()
{
	if(isObject(Suburbia_PCWSScrollBackground.currently_selected))
		if(isFunction(Suburbia_PCWSScrollBackground.currently_selected.getName(), resetSelectColors))
			Suburbia_PCWSScrollBackground.currently_selected.resetSelectColors();
}

function displayPCWS()
{
	if($Suburbia::PCWSDisplayed)
		return;
	
	for(%i = 0; %i < $Suburbia::PoliceChiefWeaponDataCount; %i++)
	{
		%weapon_name = $Suburbia::PoliceChiefWeaponData[%i];
		%icon_name = $Suburbia::PoliceChiefWeaponData[%weapon_name, "icon"];
		%cost = $Suburbia::PoliceChiefWeaponData[%weapon_name, "cost"];
		%icon = addPCWSIcon(%weapon_name, %icon_name);
		%icon.weapon_name = %weapon_name;
	}
	$Suburbia::PCWSDisplayed = true;
}

function sendPCWeapon()
{
	%selected_slot = $Suburbia::PCWSSlot;
	Canvas.popDialog(SRB_PoliceChief_WS);
	%name = Suburbia_PCWSScrollBackground.currently_selected.getGroup().weapon_name;
	
	if(%name !$= "")
		("SRB_PC_Weapon" @ %selected_slot).setText(%name SPC "-" SPC SuburbiaClient.getInflationSum($Suburbia::PoliceChiefWeaponData[%name, "cost"]));
	else
		("SRB_PC_Weapon" @ %selected_slot).setText("No Weapon Selected");
	
	CommandToServer('UpdatePoliceChiefWeapon', %name, %selected_slot);
}

function selectPCWeapon(%num)
{
	$Suburbia::PCWSSlot = %num;
	SRB_PCWS1_Button.setText("Remove Weapon from Slot");
	showPCWSGui();
}

function clientCmdUpdatePCWeapon(%ui_name, %cost, %index)
{
	if(%ui_name !$= "")
		("SRB_PC_Weapon" @ %index).setText(%ui_name SPC "-" SPC SuburbiaClient.getInflationSum(%cost));
	else
		("SRB_PC_Weapon" @ %index).setText("No Weapon Selected");
}

function clientCmdClearPoliceChiefWeapons()
{
	clearPCWS();
}








function clientCmdUpdatePoliceFunds(%amt)
{
	if(strPos(%amt, "-") != -1)
		%neg = "-";
	
	SRB_PCMoneyText.setText("<color:bbbbbb><font:Calibri:21>Funds: <color:00cc00>" @ %neg @ "$" @ addCommasToNumber(%amt));
}







function clientCmdAddPoliceBudgetHistory(%day, %text, %cost)
{
	addPoliceBudgetRow(%day, %text, %cost);
}

function addPoliceBudgetRow(%day, %text, %cost)
{
	%this = SRB_PCBudgetList;
	
	if(%this.history_start $= "")
		%this.history_start = 0;
	
	if(%this.history_end $= "")
		%this.history_end = 0;
	
	%this.budget_history[%this.history_end] = %text;
	%this.budget_history[%this.history_end, "day"] = %day;
	%this.budget_history[%this.history_end, "cost"] = %cost;
	
	if(%this.history_end - %this.history_start > 25)
		%this.history_start++;
	
	%this.history_end++;
	
	displayPoliceBudgetHistory();
}

function displayPoliceBudgetHistory()
{
	%this = SRB_PCBudgetList;
	%this.setText("");
	
	%last_date = "";
	%total_cost = "";
	
	for(%i = %this.history_end - 1; %i >= %this.history_start; %i--)
	{
		%date = %this.budget_history[%i, "day"];
		
		if(%date !$= %last_date)
		{
			if(%total_cost !$= "")
			{
				if(%total_cost > 0)
					SRB_PCBudgetListTML_addRow2("\c5Total Money Spent: $" @ mAbs(%total_cost));
				else
					SRB_PCBudgetListTML_addRow2("\c5Total Money Gained: $" @ mAbs(%total_cost));
			}
			
			if(%i != %this.history_end - 1)
				SRB_PCBudgetListTML_addRow2("");
			
			SRB_PCBudgetListTML_addRow2("\c4" @ %date);
			SRB_PCBudgetListTML_addRow2("\c4-----------------------------------------------------------");
			%last_date = %date;
			
			%total_cost = 0;
		}
		
		%total_cost += %this.budget_history[%i, "cost"];
		
		SRB_PCBudgetListTML_addRow2(%this.budget_history[%i]);
	}
	
	// displaying the total spent/gained for the last date
	if(%total_cost !$= "")
	{
		if(%total_cost > 0)
			SRB_PCBudgetListTML_addRow2("\c5Total Money Spent: $" @ mAbs(%total_cost));
		else
			SRB_PCBudgetListTML_addRow2("\c5Total Money Gained: $" @ mAbs(%total_cost));
	}
}

function SRB_PCBudgetListTML_addRow2(%text)
{
	%this = SRB_PCBudgetList;
	
	%text = "<lmargin:5>" @ %text;
	%text = strReplace(%text, "\c5", "<color:0000FF>");
	%text = strReplace(%text, "\c4", "<color:FF6060>");
	
	%this.setText(%this.getText() @ "<br><color:000000>" @ %text);
}

function clearPoliceBudgetHistory()
{
	%this = SRB_PCBudgetList;
	
	for(%i = 0; %i < %this.history_end; %i++)
	{
		%this.budget_history[%this.history_start] = "";
		%this.budget_history[%this.history_start, "day"] = "";
		%this.budget_history[%this.history_start, "cost"] = "";
	}
	
	%this.history_start = 0;
	%this.history_end = 0;
	
	displayPoliceBudgetHistory();
}















function createPCVSIcon(%name, %icon_file, %position)
{
	%gui_name = "SRB_PCVSIcon_" @ %name;
	
	%icon = new GuiSwatchCtrl(%gui_name)
	{
		clipToParent = 1;
		color = "0 0 0 255";
		enabled = 1;
		extent = "98 116";
		horizSizing = "right";
		minExtent = "1 1";
		position = %position;
		profile = "GuiDefaultProfile";
		vertSizing = "bottom";
		visible = 1;
		
		new GuiBitmapCtrl()
		{
			alignLeft = false;
			alignTop = false;
			bitmap = "Add-Ons/Client_Suburbia/gui/icons/vehicles/" @ %icon_file @ ".png";
			clipToParent = true;
			enabled = true;
			extent = "94 94";
			horizSizing = "right";
			keepCached = false;
			lockAspectRatio = false;
			mColor = "255 255 255 255";
			minExtent = "1 1";
			mMultiply = false;
			overflowImage = false;
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = true;
			wrap = false;
		};
		
		new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "ServerListProfile";
			selectable = true;
			text = "<color:ffffff><just:center><font:Arial:14>" @ %name;
			caption = %name;
			vertSizing = "bottom";
			visible = true;
		};
		
		new GuiSwatchCtrl()
		{
			clipToParent = 1;
			color = "0 0 0 0";
			enabled = 1;
			position = "0 0";
			extent = "98 116";
			horizSizing = "right";
			minExtent = "1 1";
			position = "0 0";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = 1;
		};
		
		new GuiSwatchCtrl()
		{
			clipToParent = 1;
			color = "0 0 0 0";
			enabled = 1;
			position = "2 2";
			extent = "94 94";
			horizSizing = "right";
			minExtent = "1 1";
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = 1;
		};
		
		new GuiMouseEventCtrl(SRB_PCVSIconMouse)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "98 116";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
		};
	};
	Suburbia_PCVSScrollBackground.add(%icon);
	%icon.position = %position;
	
	%icon.icon_image = %icon.getObject(0);
	%icon.icon_caption = %icon.getObject(1);
	%icon.white_tint = %icon.getObject(2);
	%icon.yellow_tint = %icon.getObject(3);
	%icon.icon_mouseCtrl = %icon.getObject(4);
	
	%icon.original_position = %position;
	
	%icon.PCVS_name = %real_name;
	
	return %gui_name;
}

function addPCVSIcon(%name, %icon_file)
{
	if(Suburbia_PCVSScroll.suburbia_currentRow $= "")
		Suburbia_PCVSScroll.suburbia_currentRow = 1;
	
	// calculate the height that we should be at
	%current_row = Suburbia_PCVSScroll.suburbia_currentRow;
	%height = (((%current_row - 1) * 116) + (%current_row * 5));
	
	// determine where along the x axis we should place the icon
	if(Suburbia_PCVSScroll.suburbia_row[%current_row, "slot"] $= "")
		Suburbia_PCVSScroll.suburbia_row[%current_row, "slot"] = 1;
	
	%current_slot = Suburbia_PCVSScroll.suburbia_row[%current_row, "slot"];
	%width = (((%current_slot - 1) * 98) + (%current_slot * 5));
	
	// create the gui and file the icon under an array all at the same time
	%icon = Suburbia_PCVSScroll.suburbia_row[%current_slot, Suburbia_PCVSScroll.suburbia_row[%current_row, "slot"]] = createPCVSIcon(%name, %icon_file, %width SPC %height);
	
	// if we have too many icons on one row, increment the total row count so next time we start on a new row
	if(Suburbia_PCVSScroll.suburbia_row[%current_row, "slot"] == 3)
		Suburbia_PCVSScroll.suburbia_currentRow++;
	else
		Suburbia_PCVSScroll.suburbia_row[%current_row, "slot"]++;
		
	// resizing the background so that the scroll works right
	%background_height = (%current_row * 116) + ((%current_row + 1) * 5);
	
	if(%background_height < 292)
		%background_height = 292;
	
	Suburbia_PCVSScrollBackground.resize(1, 1, 315, mClamp(%background_height, 344, 50000));
	
	return %icon;
}

function SRB_PCVSIconMouse::onMouseDown(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.setMouseDown();
}

function SRB_PCVSIconMouse::onMouseUp(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	if(%this.mouseDown)
		%this.setSelectColors();
}

function SRB_PCVSIconMouse::onMouseEnter(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.setHoverColors();
}

function SRB_PCVSIconMouse::onMouseLeave(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.resetHoverColors();
	
	%scroll = %this.getGroup().getGroup();
	if(%this.mouseDown == true && %this.isSelected == false && %scroll.currently_selected == %this)
		%this.resetSelectColors();
	
	if(%this.mouseDown == true)
		%this.resetMouseDown();
	
	%this.mouseDown = false;
}

function SRB_PCVSIconMouse::setHoverColors(%this)
{
	%this.getGroup().white_tint.setColor("255 255 255 90");
	
	%this.hoverActive = true;
}

function SRB_PCVSIconMouse::resetHoverColors(%this)
{
	%this.getGroup().white_tint.setColor("0 0 0 0");
	
	%this.hoverActive = false;
}

function SRB_PCVSIconMouse::setSelectColors(%this)
{
	%this.resetMouseDown();
	%parent = %this.getGroup();
	
	%parent.yellow_tint.setColor("255 255 0 115");
	%parent.icon_caption.setValue("<color:FFFF00><just:center><font:Arial:14>" @ %parent.icon_caption.caption);
	
	%scroll = %parent.getGroup();
	if(isObject(%scroll.currently_selected) && %scroll.currently_selected != %this)
		%scroll.currently_selected.resetSelectColors();
	
	// set the description shit
	Suburbia_PCVSDescTitle.setValue("<just:center><font:Arial bold:24>" @ %parent.PCVS_name);
	
	%cost = $Suburbia::PCVSData[%parent.PCVS_name, "cost"];
	if(%cost $= "")
		%cost = 0;
	
	Suburbia_PCVSDescBitmap.setBitmap("Add-Ons/Client_Suburbia/gui/icons/vehicles/" @ $Suburbia::PCVSData[%parent.PCVS_name, "icon"] @ ".png");
	Suburbia_PCVSDescCost.setValue("<font:Arial italic:15>Cost: $" @ %cost SPC "(+" SPC SuburbiaClient.getInflationDifference(%cost) @ ")");
	
	Suburbia_PCVSDescCost.extent = "500 10";
	Suburbia_PCVSDescHP.position = "120 190";
	
	Suburbia_PCVSDescHP.setValue("<font:Arial italic:15>HP:" SPC $Suburbia::PCVSData[%parent.PCVS_name, "hp"]);
	Suburbia_PCVSDescSeats.setValue("<font:Arial italic:15>Seats:" SPC $Suburbia::PCVSData[%parent.PCVS_name, "seats"]);
	
	setPCVSSpeedBar($Suburbia::PCVSData[%parent.PCVS_name, "speed"]);
	setPCVSAccelBar($Suburbia::PCVSData[%parent.PCVS_name, "accel"]);
	setPCVSBrakeBar($Suburbia::PCVSData[%parent.PCVS_name, "brake"]);
	setPCVSHandlingBar($Suburbia::PCVSData[%parent.PCVS_name, "handling"]);
	
	Suburbia_PCVSDescCover.visible = false;
	
	SRB_PCWS_Button.setText("Select" SPC %parent.PCVS_name);
	
	%scroll.currently_selected = %this;
	%this.isSelected = true;
}

function SRB_PCVSIconMouse::resetSelectColors(%this)
{
	%this.getGroup().yellow_tint.setColor("0 0 0 0");
	%this.getGroup().icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:14>" @ %this.getGroup().icon_caption.caption);
	
	%scroll = %this.getGroup().getGroup();
	if(isObject(%scroll.currently_selected) && %scroll.currently_selected != %this)
		%scroll.currently_selected.resetSelectColors();
	
	%scroll.currently_selected = "";
	
	%this.isSelected = false;
}

function SRB_PCVSIconMouse::setMouseDown(%this)
{
	%parent = %this.getGroup();
	
	if(%parent.original_position $= "")
		%parent.original_position = %parent.position;
	
	%position = %parent.original_position;
	%parent.resize(getWord(%position, 0) + 2, getWord(%position, 1) + 2, 94, 112);
	
	if(!%this.isSelected)
		%parent.icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:12>" @ %this.getGroup().icon_caption.caption);
	else
		%parent.icon_caption.setValue("<color:FFFF00><just:center><font:Arial:12>" @ %this.getGroup().icon_caption.caption);
	
	%parent.icon_caption.resize(0, 96, 92, 20);
	
	%parent.icon_image.resize(2, 2, 90, 90);
	%parent.yellow_tint.resize(2, 2, 90, 90);
	
	%this.mouseDown = true;
}

function SRB_PCVSIconMouse::resetMouseDown(%this)
{
	%parent = %this.getGroup();
	
	%position = %parent.original_position;
	%parent.resize(getWord(%position, 0), getWord(%position, 1), 98, 116);
	
	%parent.icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:14>" @ %this.getGroup().icon_caption.caption);
	%parent.icon_caption.resize(0, 99, 96, 20);
	
	%parent.icon_image.resize(2, 2, 94, 94);
	%parent.yellow_tint.resize(2, 2, 94, 94);
	
	%this.mouseDown = false;
}

function showPCVSGui()
{
	clearPCVSScrollList();
	displayPCVS();
	
	resetSelectedPCVSIcon();
	Canvas.schedule(1, pushDialog, SRB_PoliceChief_VS);
	
	SRB_PCWS_Button.setText("Remove Vehicle From Slot");
}

function resetSelectedPCVSIcon()
{
	if(isObject(Suburbia_PCVSScrollBackground.currently_selected))
		if(isFunction(Suburbia_PCVSScrollBackground.currently_selected.getName(), resetSelectColors))
			Suburbia_PCVSScrollBackground.currently_selected.resetSelectColors();
	
	Suburbia_PCVSDescCover.visible = true;
	Suburbia_PCVSDescCost.setText("");
	Suburbia_PCVSDescTitle.setText("");
	Suburbia_PCVSDescButton.setVisible(false);
}

function displayPCVS()
{
	for(%i = 0; %i < $Suburbia::PCVSDataCount; %i++)
	{
		%PCVS_name = $Suburbia::PCVSData[%i];
		%caption_name = $Suburbia::PCVSData[%PCVS_name, "caption"];
		%icon_name = $Suburbia::PCVSData[%PCVS_name, "icon"];
		%icon = addPCVSIcon(%caption_name, %icon_name);
		%icon.PCVS_name = %PCVS_name;
	}
	$Suburbia::PCVSStatsDisplayed = true;
}

function clientCmdClearPoliceVehicles()
{
	clearPCVS();
}

function clientCmdShowPCVSStatsGui(%PCVS_name)
{
	if(%PCVS_name $= "")
	{
		showPCVSGui();
	}
	else
	{
		showPCVSGui();
		%obj = ("SRB_PCVSIcon_" @ %PCVS_name);
		%obj.getObject(%obj.getCount() - 1).setSelectColors();
		
		%max_y = getWord(Suburbia_PCVSScrollBackground, 1);
		%y = getWord(%obj.position, 1) - 116 + 20;
		
		Suburbia_PCVSScrollBackground.position = "1" SPC -mClamp(%y, 0, 5393);
	}
}

function clientCmdRecievePCVSData(%vehicle_name, %caption_name, %cost, %speed, %accel, %brake, %handling, %seats, %hp)
{
	%icon_name = getSafeVariableName(%vehicle_name);
	
	$Suburbia::PCVSData[%vehicle_name] = true;
	$Suburbia::PCVSData[%vehicle_name, "caption"] = %caption_name;
	$Suburbia::PCVSData[%vehicle_name, "icon"] = %icon_name;
	$Suburbia::PCVSData[%vehicle_name, "cost"] = %cost;
	$Suburbia::PCVSData[%vehicle_name, "speed"] = %speed;
	$Suburbia::PCVSData[%vehicle_name, "accel"] = %accel;
	$Suburbia::PCVSData[%vehicle_name, "brake"] = %brake;
	$Suburbia::PCVSData[%vehicle_name, "handling"] = %handling;
	$Suburbia::PCVSData[%vehicle_name, "seats"] = %seats;
	$Suburbia::PCVSData[%vehicle_name, "hp"] = %hp;
	
	if($Suburbia::PCVSDataCount $= "")
		$Suburbia::PCVSDataCount = 0;
	
	$Suburbia::PCVSData[$Suburbia::PCVSDataCount] = %vehicle_name;
	$Suburbia::PCVSDataCount++;
}

function clearPCVS()
{
	$Suburbia::PCVSStatsDisplayed = false;
	DeleteVariables("$Suburbia::PCVSData*");
	clearPCVSScrollList();
}

function clearPCVSScrollList()
{
	%count = getTaggedFieldCount(Suburbia_PCVSScroll);
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%field = Suburbia_PCVSScroll.getTaggedField(%i);
		%field_name = expandEscape(getField(%field, 0));
		eval("Suburbia_PCVSScroll." @ %field_name @ " = \"\";");
	}
	
	%count = Suburbia_PCVSScrollBackground.getCount();
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%obj = Suburbia_PCVSScrollBackground.getObject(%i);
		
		if(isObject(%obj))
			%obj.delete();
	}
}

function setPCVSSpeedBar(%speed)
{
	%percent = mClampF((0.01666 * %speed) - 0.335, 0.05, 1);
	setPCVSStatBar(Suburbia_PCVSSpeedBarBitmap, Suburbia_PCVSSpeedBarBCap, %percent);
}

function setPCVSAccelBar(%accel)
{
	%percent = mClampF((0.0415546 * %accel) - 0.2652, 0.05, 1);
	setPCVSStatBar(Suburbia_PCVSAccelBarBitmap, Suburbia_PCVSAccelBarBCap, %percent);
}

function setPCVSBrakeBar(%brake)
{
	%percent = mClampF((-0.0297609724 * %brake) + 1.0972, 0.05, 1);
	setPCVSStatBar(Suburbia_PCVSBrakeBarBitmap, Suburbia_PCVSBrakeBarBCap, %percent);
}

function setPCVSHandlingBar(%handling)
{
	// echo(%handling SPC "<= z");
	%percent = mClampF(((0.182093 * %handling) + 0.012) * 100, 5, 100);
	%percent /= 100;
	setPCVSStatBar(Suburbia_PCVSHandlingBarBitmap, Suburbia_PCVSHandlingBarBCap, %percent);
}

function setPCVSStatBar(%bar, %end, %percent)
{
	%width = mFloor(223 * %percent);
	%bar.extent = %width SPC "7";
	%end.position = getWord(%bar.position, 0) + %width SPC getWord(%end.position, 1);
}

function selectPoliceVehicle()
{
	Canvas.popDialog(SRB_PoliceChief_VS);
	%slot = SuburbiaClient.pcvehicleslot;
	
	if(isObject(Suburbia_PCVSScrollBackground.currently_selected))
	{
		%name = Suburbia_PCVSScrollBackground.currently_selected.getGroup().PCVS_name;
		("SRB_PC_Vehicle" @ %slot).setText(%name SPC "-" SPC SuburbiaClient.getInflationSum($Suburbia::PCVSData[%name, "cost"]));
		("SRB_PC_Vehicle" @ %slot).cost = $Suburbia::PCVSData[%name, "cost"];
		("SRB_PC_Vehicle" @ %slot).name = %name;
		CommandToServer('UpdatePoliceChiefVehicle', %name, %slot);
	}
	else
	{
		("SRB_PC_Vehicle" @ %slot).setText("No Vehicle Selected");
		("SRB_PC_Vehicle" @ %slot).name = "";
		CommandToServer('UpdatePoliceChiefVehicle', "", %slot);
	}
}

function selectPCVehicle(%slot)
{
	SuburbiaClient.pcvehicleslot = %slot;
	showPCVSGui();
}

function clientCmdUpdatePCVehicle(%index, %name)
{
	if(%name !$= "")
	{
		("SRB_PC_Vehicle" @ %index).setText(%name SPC "-" SPC SuburbiaClient.getInflationSum($Suburbia::PCVSData[%name, "cost"]));
		("SRB_PC_Vehicle" @ %slot).cost = $Suburbia::PCVSData[%name, "cost"];
		("SRB_PC_Vehicle" @ %slot).name = %name;
	}
	else
	{
		("SRB_PC_Vehicle" @ %index).setText("No Vehicle Selected");
		("SRB_PC_Vehicle" @ %slot).name = "";
	}
}