function suburbia_setIncomeTax(%val)
{
	SuburbiaClient.value["income_tax"] = mFloor(%val * 100);
	Suburbia_MayorIncomeTaxText.setValue("<just:center><color:ffff00><font:Calibri Bold:26>Income Tax: <color:ffffff>" @ SuburbiaClient.value["income_tax"] @ "%");
}

function suburbia_setSalesTax(%val)
{
	SuburbiaClient.value["sales_tax"] = mFloor(%val * 100);
	Suburbia_MayorSalesTaxText.setValue("<just:center><color:ffff00><font:Calibri Bold:26>Sales Tax: <color:ffffff>" @ SuburbiaClient.value["sales_tax"] @ "%");
}

function suburbia_setExportTax(%val)
{
	SuburbiaClient.value["export_tax"] = mFloor(%val * 100);
	Suburbia_MayorExportTaxText.setValue("<just:center><color:ffff00><font:Calibri Bold:26>Export Tax: <color:ffffff>" @ SuburbiaClient.value["export_tax"] @ "%");
}

function suburbia_setDeathTax(%val)
{
	SuburbiaClient.value["death_tax"] = mFloor(%val * 100);
	
	if(SuburbiaClient.value["death_tax"] < 0)
	{
		%tax_name = "Social Security";
		
		SRB_MayorSocialSecurityCutoff.visible = true;
		SRB_MayorSocialSecurityCutoffTxt.visible = true;
		
		SRB_MayorSocialSecurityMax.visible = true;
		SRB_MayorSocialSecurityMaxTxt.visible = true;
		
		SRB_DeathTax_Container.extent = "314 97";
	}
	else
	{
		%tax_name = "Death Tax";
		
		SRB_MayorSocialSecurityCutoff.visible = false;
		SRB_MayorSocialSecurityCutoffTxt.visible = false;
		
		SRB_MayorSocialSecurityMax.visible = false;
		SRB_MayorSocialSecurityMaxTxt.visible = false;
		
		SRB_DeathTax_Container.extent = "314 81";
	}
	
	Suburbia_MayorDeathTaxText.setValue("<just:center><color:ffff00><font:Calibri Bold:26>" @ %tax_name @ ": <color:ffffff>" @ mAbs(SuburbiaClient.value["death_tax"]) @ "%");
}

function suburbia_sendTaxUpdate()
{
	CommandToServer('UpdateGovTax', SuburbiaClient.value["income_tax"] / 100);
	CommandToServer('UpdateSalesTax', SuburbiaClient.value["sales_tax"] / 100);
	CommandToServer('UpdateExportTax', SuburbiaClient.value["export_tax"] / 100);
	CommandToServer('UpdateDeathTax', SuburbiaClient.value["death_tax"] / 100, SRB_MayorSocialSecurityCutoff.getValue(), SRB_MayorSocialSecurityMax.getValue());
}

function clientCmdUpdateGovTax(%inc_tax, %sales_tax, %death_tax, %cutoff, %max, %export_tax)
{
	Suburbia_IncomeTaxSlider.setValue(%inc_tax);
	suburbia_setIncomeTax(%inc_tax);
	
	Suburbia_SalesTaxSlider.setValue(%sales_tax);
	suburbia_setSalesTax(%sales_tax);
	
	Suburbia_ExportTaxSlider.setValue(%export_tax);
	suburbia_setExportTax(%export_tax);
	
	Suburbia_DeathTaxSlider.setValue(%death_tax);
	suburbia_setDeathTax(%death_tax);
	
	SRB_MayorSocialSecurityCutoff.setValue(%cutoff);
	SRB_MayorSocialSecurityMax.setValue(%max);
}